/**
 * @license
 * Cesium - https://github.com/CesiumGS/cesium
 * Version 1.114
 *
 * Copyright 2011-2022 Cesium Contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Columbus View (Pat. Pend.)
 *
 * Portions licensed separately.
 * See https://github.com/CesiumGS/cesium/blob/main/LICENSE.md for full licensing details.
 */

import{a as ze}from"./chunk-YIJHUUZY.js";import{a as Ot,b as L,c as vt}from"./chunk-CSZ6CHXI.js";import{a as f,b as De,c as an,d as qe,e as B}from"./chunk-IGBMENRT.js";import{a as X}from"./chunk-SEE54P6A.js";import{a as Re}from"./chunk-4Z3GDVJK.js";import{a as O}from"./chunk-LU3FCBPP.js";import{a as A,b as h}from"./chunk-S2577PU4.js";import{a as xt,c as St,d as Ge,e as d}from"./chunk-2TPVVSVW.js";var sr=St((et,tt)=>{/*! https://mths.be/punycode v1.4.0 by @mathias */(function(e){var t=typeof et=="object"&&et&&!et.nodeType&&et,n=typeof tt=="object"&&tt&&!tt.nodeType&&tt,i=typeof global=="object"&&global;(i.global===i||i.window===i||i.self===i)&&(e=i);var s,r=2147483647,c=36,u=1,p=26,b=38,g=700,w=72,x=128,R="-",I=/^xn--/,T=/[^\x20-\x7E]/,M=/[\x2E\u3002\uFF0E\uFF61]/g,U={overflow:"Overflow: input needs wider integers to process","not-basic":"Illegal input >= 0x80 (not a basic code point)","invalid-input":"Invalid input"},k=c-u,q=Math.floor,F=String.fromCharCode,j;function H(y){throw new RangeError(U[y])}function oe(y,P){for(var z=y.length,V=[];z--;)V[z]=P(y[z]);return V}function ie(y,P){var z=y.split("@"),V="";z.length>1&&(V=z[0]+"@",y=z[1]),y=y.replace(M,".");var ne=y.split("."),se=oe(ne,P).join(".");return V+se}function J(y){for(var P=[],z=0,V=y.length,ne,se;z<V;)ne=y.charCodeAt(z++),ne>=55296&&ne<=56319&&z<V?(se=y.charCodeAt(z++),(se&64512)==56320?P.push(((ne&1023)<<10)+(se&1023)+65536):(P.push(ne),z--)):P.push(ne);return P}function W(y){return oe(y,function(P){var z="";return P>65535&&(P-=65536,z+=F(P>>>10&1023|55296),P=56320|P&1023),z+=F(P),z}).join("")}function Q(y){return y-48<10?y-22:y-65<26?y-65:y-97<26?y-97:c}function o(y,P){return y+22+75*(y<26)-((P!=0)<<5)}function a(y,P,z){var V=0;for(y=z?q(y/g):y>>1,y+=q(y/P);y>k*p>>1;V+=c)y=q(y/k);return q(V+(k+1)*y/(y+b))}function l(y){var P=[],z=y.length,V,ne=0,se=x,G=w,ae,he,be,ye,fe,_e,Se,Ue,Le;for(ae=y.lastIndexOf(R),ae<0&&(ae=0),he=0;he<ae;++he)y.charCodeAt(he)>=128&&H("not-basic"),P.push(y.charCodeAt(he));for(be=ae>0?ae+1:0;be<z;){for(ye=ne,fe=1,_e=c;be>=z&&H("invalid-input"),Se=Q(y.charCodeAt(be++)),(Se>=c||Se>q((r-ne)/fe))&&H("overflow"),ne+=Se*fe,Ue=_e<=G?u:_e>=G+p?p:_e-G,!(Se<Ue);_e+=c)Le=c-Ue,fe>q(r/Le)&&H("overflow"),fe*=Le;V=P.length+1,G=a(ne-ye,V,ye==0),q(ne/V)>r-se&&H("overflow"),se+=q(ne/V),ne%=V,P.splice(ne++,0,se)}return W(P)}function m(y){var P,z,V,ne,se,G,ae,he,be,ye,fe,_e=[],Se,Ue,Le,sn;for(y=J(y),Se=y.length,P=x,z=0,se=w,G=0;G<Se;++G)fe=y[G],fe<128&&_e.push(F(fe));for(V=ne=_e.length,ne&&_e.push(R);V<Se;){for(ae=r,G=0;G<Se;++G)fe=y[G],fe>=P&&fe<ae&&(ae=fe);for(Ue=V+1,ae-P>q((r-z)/Ue)&&H("overflow"),z+=(ae-P)*Ue,P=ae,G=0;G<Se;++G)if(fe=y[G],fe<P&&++z>r&&H("overflow"),fe==P){for(he=z,be=c;ye=be<=se?u:be>=se+p?p:be-se,!(he<ye);be+=c)sn=he-ye,Le=c-ye,_e.push(F(o(ye+sn%Le,0))),he=q(sn/Le);_e.push(F(o(he,0))),se=a(z,Ue,V==ne),z=0,++V}++z,++P}return _e.join("")}function _(y){return ie(y,function(P){return I.test(P)?l(P.slice(4).toLowerCase()):P})}function v(y){return ie(y,function(P){return T.test(P)?"xn--"+m(P):P})}if(s={version:"1.3.2",ucs2:{decode:J,encode:W},decode:l,encode:m,toASCII:v,toUnicode:_},typeof define=="function"&&typeof define.amd=="object"&&define.amd)define("punycode",function(){return s});else if(t&&n)if(tt.exports==t)n.exports=s;else for(j in s)s.hasOwnProperty(j)&&(t[j]=s[j]);else e.punycode=s})(et)});var cr=St((ar,Ut)=>{/*!
 * URI.js - Mutating URLs
 * IPv6 Support
 *
 * Version: 1.19.11
 *
 * Author: Rodney Rehm
 * Web: http://medialize.github.io/URI.js/
 *
 * Licensed under
 *   MIT License http://www.opensource.org/licenses/mit-license
 *
 */(function(e,t){"use strict";typeof Ut=="object"&&Ut.exports?Ut.exports=t():typeof define=="function"&&define.amd?define(t):e.IPv6=t(e)})(ar,function(e){"use strict";var t=e&&e.IPv6;function n(s){var r=s.toLowerCase(),c=r.split(":"),u=c.length,p=8;c[0]===""&&c[1]===""&&c[2]===""?(c.shift(),c.shift()):c[0]===""&&c[1]===""?c.shift():c[u-1]===""&&c[u-2]===""&&c.pop(),u=c.length,c[u-1].indexOf(".")!==-1&&(p=7);var b;for(b=0;b<u&&c[b]!=="";b++);if(b<p)for(c.splice(b,1,"0000");c.length<p;)c.splice(b,0,"0000");for(var g,w=0;w<p;w++){g=c[w].split("");for(var x=0;x<3&&(g[0]==="0"&&g.length>1);x++)g.splice(0,1);c[w]=g.join("")}var R=-1,I=0,T=0,M=-1,U=!1;for(w=0;w<p;w++)U?c[w]==="0"?T+=1:(U=!1,T>I&&(R=M,I=T)):c[w]==="0"&&(U=!0,M=w,T=1);T>I&&(R=M,I=T),I>1&&c.splice(R,I,""),u=c.length;var k="";for(c[0]===""&&(k=":"),w=0;w<u&&(k+=c[w],w!==u-1);w++)k+=":";return c[u-1]===""&&(k+=":"),k}function i(){return e.IPv6===this&&(e.IPv6=t),this}return{best:n,noConflict:i}})});var fr=St((ur,Dt)=>{/*!
 * URI.js - Mutating URLs
 * Second Level Domain (SLD) Support
 *
 * Version: 1.19.11
 *
 * Author: Rodney Rehm
 * Web: http://medialize.github.io/URI.js/
 *
 * Licensed under
 *   MIT License http://www.opensource.org/licenses/mit-license
 *
 */(function(e,t){"use strict";typeof Dt=="object"&&Dt.exports?Dt.exports=t():typeof define=="function"&&define.amd?define(t):e.SecondLevelDomains=t(e)})(ur,function(e){"use strict";var t=e&&e.SecondLevelDomains,n={list:{ac:" com gov mil net org ",ae:" ac co gov mil name net org pro sch ",af:" com edu gov net org ",al:" com edu gov mil net org ",ao:" co ed gv it og pb ",ar:" com edu gob gov int mil net org tur ",at:" ac co gv or ",au:" asn com csiro edu gov id net org ",ba:" co com edu gov mil net org rs unbi unmo unsa untz unze ",bb:" biz co com edu gov info net org store tv ",bh:" biz cc com edu gov info net org ",bn:" com edu gov net org ",bo:" com edu gob gov int mil net org tv ",br:" adm adv agr am arq art ato b bio blog bmd cim cng cnt com coop ecn edu eng esp etc eti far flog fm fnd fot fst g12 ggf gov imb ind inf jor jus lel mat med mil mus net nom not ntr odo org ppg pro psc psi qsl rec slg srv tmp trd tur tv vet vlog wiki zlg ",bs:" com edu gov net org ",bz:" du et om ov rg ",ca:" ab bc mb nb nf nl ns nt nu on pe qc sk yk ",ck:" biz co edu gen gov info net org ",cn:" ac ah bj com cq edu fj gd gov gs gx gz ha hb he hi hl hn jl js jx ln mil net nm nx org qh sc sd sh sn sx tj tw xj xz yn zj ",co:" com edu gov mil net nom org ",cr:" ac c co ed fi go or sa ",cy:" ac biz com ekloges gov ltd name net org parliament press pro tm ",do:" art com edu gob gov mil net org sld web ",dz:" art asso com edu gov net org pol ",ec:" com edu fin gov info med mil net org pro ",eg:" com edu eun gov mil name net org sci ",er:" com edu gov ind mil net org rochest w ",es:" com edu gob nom org ",et:" biz com edu gov info name net org ",fj:" ac biz com info mil name net org pro ",fk:" ac co gov net nom org ",fr:" asso com f gouv nom prd presse tm ",gg:" co net org ",gh:" com edu gov mil org ",gn:" ac com gov net org ",gr:" com edu gov mil net org ",gt:" com edu gob ind mil net org ",gu:" com edu gov net org ",hk:" com edu gov idv net org ",hu:" 2000 agrar bolt casino city co erotica erotika film forum games hotel info ingatlan jogasz konyvelo lakas media news org priv reklam sex shop sport suli szex tm tozsde utazas video ",id:" ac co go mil net or sch web ",il:" ac co gov idf k12 muni net org ",in:" ac co edu ernet firm gen gov i ind mil net nic org res ",iq:" com edu gov i mil net org ",ir:" ac co dnssec gov i id net org sch ",it:" edu gov ",je:" co net org ",jo:" com edu gov mil name net org sch ",jp:" ac ad co ed go gr lg ne or ",ke:" ac co go info me mobi ne or sc ",kh:" com edu gov mil net org per ",ki:" biz com de edu gov info mob net org tel ",km:" asso com coop edu gouv k medecin mil nom notaires pharmaciens presse tm veterinaire ",kn:" edu gov net org ",kr:" ac busan chungbuk chungnam co daegu daejeon es gangwon go gwangju gyeongbuk gyeonggi gyeongnam hs incheon jeju jeonbuk jeonnam k kg mil ms ne or pe re sc seoul ulsan ",kw:" com edu gov net org ",ky:" com edu gov net org ",kz:" com edu gov mil net org ",lb:" com edu gov net org ",lk:" assn com edu gov grp hotel int ltd net ngo org sch soc web ",lr:" com edu gov net org ",lv:" asn com conf edu gov id mil net org ",ly:" com edu gov id med net org plc sch ",ma:" ac co gov m net org press ",mc:" asso tm ",me:" ac co edu gov its net org priv ",mg:" com edu gov mil nom org prd tm ",mk:" com edu gov inf name net org pro ",ml:" com edu gov net org presse ",mn:" edu gov org ",mo:" com edu gov net org ",mt:" com edu gov net org ",mv:" aero biz com coop edu gov info int mil museum name net org pro ",mw:" ac co com coop edu gov int museum net org ",mx:" com edu gob net org ",my:" com edu gov mil name net org sch ",nf:" arts com firm info net other per rec store web ",ng:" biz com edu gov mil mobi name net org sch ",ni:" ac co com edu gob mil net nom org ",np:" com edu gov mil net org ",nr:" biz com edu gov info net org ",om:" ac biz co com edu gov med mil museum net org pro sch ",pe:" com edu gob mil net nom org sld ",ph:" com edu gov i mil net ngo org ",pk:" biz com edu fam gob gok gon gop gos gov net org web ",pl:" art bialystok biz com edu gda gdansk gorzow gov info katowice krakow lodz lublin mil net ngo olsztyn org poznan pwr radom slupsk szczecin torun warszawa waw wroc wroclaw zgora ",pr:" ac biz com edu est gov info isla name net org pro prof ",ps:" com edu gov net org plo sec ",pw:" belau co ed go ne or ",ro:" arts com firm info nom nt org rec store tm www ",rs:" ac co edu gov in org ",sb:" com edu gov net org ",sc:" com edu gov net org ",sh:" co com edu gov net nom org ",sl:" com edu gov net org ",st:" co com consulado edu embaixada gov mil net org principe saotome store ",sv:" com edu gob org red ",sz:" ac co org ",tr:" av bbs bel biz com dr edu gen gov info k12 name net org pol tel tsk tv web ",tt:" aero biz cat co com coop edu gov info int jobs mil mobi museum name net org pro tel travel ",tw:" club com ebiz edu game gov idv mil net org ",mu:" ac co com gov net or org ",mz:" ac co edu gov org ",na:" co com ",nz:" ac co cri geek gen govt health iwi maori mil net org parliament school ",pa:" abo ac com edu gob ing med net nom org sld ",pt:" com edu gov int net nome org publ ",py:" com edu gov mil net org ",qa:" com edu gov mil net org ",re:" asso com nom ",ru:" ac adygeya altai amur arkhangelsk astrakhan bashkiria belgorod bir bryansk buryatia cbg chel chelyabinsk chita chukotka chuvashia com dagestan e-burg edu gov grozny int irkutsk ivanovo izhevsk jar joshkar-ola kalmykia kaluga kamchatka karelia kazan kchr kemerovo khabarovsk khakassia khv kirov koenig komi kostroma kranoyarsk kuban kurgan kursk lipetsk magadan mari mari-el marine mil mordovia mosreg msk murmansk nalchik net nnov nov novosibirsk nsk omsk orenburg org oryol penza perm pp pskov ptz rnd ryazan sakhalin samara saratov simbirsk smolensk spb stavropol stv surgut tambov tatarstan tom tomsk tsaritsyn tsk tula tuva tver tyumen udm udmurtia ulan-ude vladikavkaz vladimir vladivostok volgograd vologda voronezh vrn vyatka yakutia yamal yekaterinburg yuzhno-sakhalinsk ",rw:" ac co com edu gouv gov int mil net ",sa:" com edu gov med net org pub sch ",sd:" com edu gov info med net org tv ",se:" a ac b bd c d e f g h i k l m n o org p parti pp press r s t tm u w x y z ",sg:" com edu gov idn net org per ",sn:" art com edu gouv org perso univ ",sy:" com edu gov mil net news org ",th:" ac co go in mi net or ",tj:" ac biz co com edu go gov info int mil name net nic org test web ",tn:" agrinet com defense edunet ens fin gov ind info intl mincom nat net org perso rnrt rns rnu tourism ",tz:" ac co go ne or ",ua:" biz cherkassy chernigov chernovtsy ck cn co com crimea cv dn dnepropetrovsk donetsk dp edu gov if in ivano-frankivsk kh kharkov kherson khmelnitskiy kiev kirovograd km kr ks kv lg lugansk lutsk lviv me mk net nikolaev od odessa org pl poltava pp rovno rv sebastopol sumy te ternopil uzhgorod vinnica vn zaporizhzhe zhitomir zp zt ",ug:" ac co go ne or org sc ",uk:" ac bl british-library co cym gov govt icnet jet lea ltd me mil mod national-library-scotland nel net nhs nic nls org orgn parliament plc police sch scot soc ",us:" dni fed isa kids nsn ",uy:" com edu gub mil net org ",ve:" co com edu gob info mil net org web ",vi:" co com k12 net org ",vn:" ac biz com edu gov health info int name net org pro ",ye:" co com gov ltd me net org plc ",yu:" ac co edu gov org ",za:" ac agric alt bourse city co cybernet db edu gov grondar iaccess imt inca landesign law mil net ngo nis nom olivetti org pix school tm web ",zm:" ac co com edu gov net org sch ",com:"ar br cn de eu gb gr hu jpn kr no qc ru sa se uk us uy za ",net:"gb jp se uk ",org:"ae",de:"com "},has:function(i){var s=i.lastIndexOf(".");if(s<=0||s>=i.length-1)return!1;var r=i.lastIndexOf(".",s-1);if(r<=0||r>=s-1)return!1;var c=n.list[i.slice(s+1)];return c?c.indexOf(" "+i.slice(r+1,s)+" ")>=0:!1},is:function(i){var s=i.lastIndexOf(".");if(s<=0||s>=i.length-1)return!1;var r=i.lastIndexOf(".",s-1);if(r>=0)return!1;var c=n.list[i.slice(s+1)];return c?c.indexOf(" "+i.slice(0,s)+" ")>=0:!1},get:function(i){var s=i.lastIndexOf(".");if(s<=0||s>=i.length-1)return null;var r=i.lastIndexOf(".",s-1);if(r<=0||r>=s-1)return null;var c=n.list[i.slice(s+1)];return!c||c.indexOf(" "+i.slice(r+1,s)+" ")<0?null:i.slice(r+1)},noConflict:function(){return e.SecondLevelDomains===this&&(e.SecondLevelDomains=t),this}};return n})});var $e=St((lr,qt)=>{/*!
 * URI.js - Mutating URLs
 *
 * Version: 1.19.11
 *
 * Author: Rodney Rehm
 * Web: http://medialize.github.io/URI.js/
 *
 * Licensed under
 *   MIT License http://www.opensource.org/licenses/mit-license
 *
 */(function(e,t){"use strict";typeof qt=="object"&&qt.exports?qt.exports=t(sr(),cr(),fr()):typeof define=="function"&&define.amd?define(["./punycode","./IPv6","./SecondLevelDomains"],t):e.URI=t(e.punycode,e.IPv6,e.SecondLevelDomains,e)})(lr,function(e,t,n,i){"use strict";var s=i&&i.URI;function r(o,a){var l=arguments.length>=1,m=arguments.length>=2;if(!(this instanceof r))return l?m?new r(o,a):new r(o):new r;if(o===void 0){if(l)throw new TypeError("undefined is not a valid argument for URI");typeof location<"u"?o=location.href+"":o=""}if(o===null&&l)throw new TypeError("null is not a valid argument for URI");return this.href(o),a!==void 0?this.absoluteTo(a):this}function c(o){return/^[0-9]+$/.test(o)}r.version="1.19.11";var u=r.prototype,p=Object.prototype.hasOwnProperty;function b(o){return o.replace(/([.*+?^=!:${}()|[\]\/\\])/g,"\\$1")}function g(o){return o===void 0?"Undefined":String(Object.prototype.toString.call(o)).slice(8,-1)}function w(o){return g(o)==="Array"}function x(o,a){var l={},m,_;if(g(a)==="RegExp")l=null;else if(w(a))for(m=0,_=a.length;m<_;m++)l[a[m]]=!0;else l[a]=!0;for(m=0,_=o.length;m<_;m++){var v=l&&l[o[m]]!==void 0||!l&&a.test(o[m]);v&&(o.splice(m,1),_--,m--)}return o}function R(o,a){var l,m;if(w(a)){for(l=0,m=a.length;l<m;l++)if(!R(o,a[l]))return!1;return!0}var _=g(a);for(l=0,m=o.length;l<m;l++)if(_==="RegExp"){if(typeof o[l]=="string"&&o[l].match(a))return!0}else if(o[l]===a)return!0;return!1}function I(o,a){if(!w(o)||!w(a)||o.length!==a.length)return!1;o.sort(),a.sort();for(var l=0,m=o.length;l<m;l++)if(o[l]!==a[l])return!1;return!0}function T(o){var a=/^\/+|\/+$/g;return o.replace(a,"")}r._parts=function(){return{protocol:null,username:null,password:null,hostname:null,urn:null,port:null,path:null,query:null,fragment:null,preventInvalidHostname:r.preventInvalidHostname,duplicateQueryParameters:r.duplicateQueryParameters,escapeQuerySpace:r.escapeQuerySpace}},r.preventInvalidHostname=!1,r.duplicateQueryParameters=!1,r.escapeQuerySpace=!0,r.protocol_expression=/^[a-z][a-z0-9.+-]*$/i,r.idn_expression=/[^a-z0-9\._-]/i,r.punycode_expression=/(xn--)/i,r.ip4_expression=/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/,r.ip6_expression=/^\s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(%.+)?\s*$/,r.find_uri_expression=/\b((?:[a-z][\w-]+:(?:\/{1,3}|[a-z0-9%])|www\d{0,3}[.]|[a-z0-9.\-]+[.][a-z]{2,4}\/)(?:[^\s()<>]+|\(([^\s()<>]+|(\([^\s()<>]+\)))*\))+(?:\(([^\s()<>]+|(\([^\s()<>]+\)))*\)|[^\s`!()\[\]{};:'".,<>?«»“”‘’]))/ig,r.findUri={start:/\b(?:([a-z][a-z0-9.+-]*:\/\/)|www\.)/gi,end:/[\s\r\n]|$/,trim:/[`!()\[\]{};:'".,<>?«»“”„‘’]+$/,parens:/(\([^\)]*\)|\[[^\]]*\]|\{[^}]*\}|<[^>]*>)/g},r.leading_whitespace_expression=/^[\x00-\x20\u00a0\u1680\u2000-\u200a\u2028\u2029\u202f\u205f\u3000\ufeff]+/,r.ascii_tab_whitespace=/[\u0009\u000A\u000D]+/g,r.defaultPorts={http:"80",https:"443",ftp:"21",gopher:"70",ws:"80",wss:"443"},r.hostProtocols=["http","https"],r.invalid_hostname_characters=/[^a-zA-Z0-9\.\-:_]/,r.domAttributes={a:"href",blockquote:"cite",link:"href",base:"href",script:"src",form:"action",img:"src",area:"href",iframe:"src",embed:"src",source:"src",track:"src",input:"src",audio:"src",video:"src"},r.getDomAttribute=function(o){if(!(!o||!o.nodeName)){var a=o.nodeName.toLowerCase();if(!(a==="input"&&o.type!=="image"))return r.domAttributes[a]}};function M(o){return escape(o)}function U(o){return encodeURIComponent(o).replace(/[!'()*]/g,M).replace(/\*/g,"%2A")}r.encode=U,r.decode=decodeURIComponent,r.iso8859=function(){r.encode=escape,r.decode=unescape},r.unicode=function(){r.encode=U,r.decode=decodeURIComponent},r.characters={pathname:{encode:{expression:/%(24|26|2B|2C|3B|3D|3A|40)/ig,map:{"%24":"$","%26":"&","%2B":"+","%2C":",","%3B":";","%3D":"=","%3A":":","%40":"@"}},decode:{expression:/[\/\?#]/g,map:{"/":"%2F","?":"%3F","#":"%23"}}},reserved:{encode:{expression:/%(21|23|24|26|27|28|29|2A|2B|2C|2F|3A|3B|3D|3F|40|5B|5D)/ig,map:{"%3A":":","%2F":"/","%3F":"?","%23":"#","%5B":"[","%5D":"]","%40":"@","%21":"!","%24":"$","%26":"&","%27":"'","%28":"(","%29":")","%2A":"*","%2B":"+","%2C":",","%3B":";","%3D":"="}}},urnpath:{encode:{expression:/%(21|24|27|28|29|2A|2B|2C|3B|3D|40)/ig,map:{"%21":"!","%24":"$","%27":"'","%28":"(","%29":")","%2A":"*","%2B":"+","%2C":",","%3B":";","%3D":"=","%40":"@"}},decode:{expression:/[\/\?#:]/g,map:{"/":"%2F","?":"%3F","#":"%23",":":"%3A"}}}},r.encodeQuery=function(o,a){var l=r.encode(o+"");return a===void 0&&(a=r.escapeQuerySpace),a?l.replace(/%20/g,"+"):l},r.decodeQuery=function(o,a){o+="",a===void 0&&(a=r.escapeQuerySpace);try{return r.decode(a?o.replace(/\+/g,"%20"):o)}catch{return o}};var k={encode:"encode",decode:"decode"},q,F=function(o,a){return function(l){try{return r[a](l+"").replace(r.characters[o][a].expression,function(m){return r.characters[o][a].map[m]})}catch{return l}}};for(q in k)r[q+"PathSegment"]=F("pathname",k[q]),r[q+"UrnPathSegment"]=F("urnpath",k[q]);var j=function(o,a,l){return function(m){var _;l?_=function(z){return r[a](r[l](z))}:_=r[a];for(var v=(m+"").split(o),y=0,P=v.length;y<P;y++)v[y]=_(v[y]);return v.join(o)}};r.decodePath=j("/","decodePathSegment"),r.decodeUrnPath=j(":","decodeUrnPathSegment"),r.recodePath=j("/","encodePathSegment","decode"),r.recodeUrnPath=j(":","encodeUrnPathSegment","decode"),r.encodeReserved=F("reserved","encode"),r.parse=function(o,a){var l;return a||(a={preventInvalidHostname:r.preventInvalidHostname}),o=o.replace(r.leading_whitespace_expression,""),o=o.replace(r.ascii_tab_whitespace,""),l=o.indexOf("#"),l>-1&&(a.fragment=o.substring(l+1)||null,o=o.substring(0,l)),l=o.indexOf("?"),l>-1&&(a.query=o.substring(l+1)||null,o=o.substring(0,l)),o=o.replace(/^(https?|ftp|wss?)?:+[/\\]*/i,"$1://"),o=o.replace(/^[/\\]{2,}/i,"//"),o.substring(0,2)==="//"?(a.protocol=null,o=o.substring(2),o=r.parseAuthority(o,a)):(l=o.indexOf(":"),l>-1&&(a.protocol=o.substring(0,l)||null,a.protocol&&!a.protocol.match(r.protocol_expression)?a.protocol=void 0:o.substring(l+1,l+3).replace(/\\/g,"/")==="//"?(o=o.substring(l+3),o=r.parseAuthority(o,a)):(o=o.substring(l+1),a.urn=!0))),a.path=o,a},r.parseHost=function(o,a){o||(o=""),o=o.replace(/\\/g,"/");var l=o.indexOf("/"),m,_;if(l===-1&&(l=o.length),o.charAt(0)==="[")m=o.indexOf("]"),a.hostname=o.substring(1,m)||null,a.port=o.substring(m+2,l)||null,a.port==="/"&&(a.port=null);else{var v=o.indexOf(":"),y=o.indexOf("/"),P=o.indexOf(":",v+1);P!==-1&&(y===-1||P<y)?(a.hostname=o.substring(0,l)||null,a.port=null):(_=o.substring(0,l).split(":"),a.hostname=_[0]||null,a.port=_[1]||null)}return a.hostname&&o.substring(l).charAt(0)!=="/"&&(l++,o="/"+o),a.preventInvalidHostname&&r.ensureValidHostname(a.hostname,a.protocol),a.port&&r.ensureValidPort(a.port),o.substring(l)||"/"},r.parseAuthority=function(o,a){return o=r.parseUserinfo(o,a),r.parseHost(o,a)},r.parseUserinfo=function(o,a){var l=o,m=o.indexOf("\\");m!==-1&&(o=o.replace(/\\/g,"/"));var _=o.indexOf("/"),v=o.lastIndexOf("@",_>-1?_:o.length-1),y;return v>-1&&(_===-1||v<_)?(y=o.substring(0,v).split(":"),a.username=y[0]?r.decode(y[0]):null,y.shift(),a.password=y[0]?r.decode(y.join(":")):null,o=l.substring(v+1)):(a.username=null,a.password=null),o},r.parseQuery=function(o,a){if(!o)return{};if(o=o.replace(/&+/g,"&").replace(/^\?*&*|&+$/g,""),!o)return{};for(var l={},m=o.split("&"),_=m.length,v,y,P,z=0;z<_;z++)v=m[z].split("="),y=r.decodeQuery(v.shift(),a),P=v.length?r.decodeQuery(v.join("="),a):null,y!=="__proto__"&&(p.call(l,y)?((typeof l[y]=="string"||l[y]===null)&&(l[y]=[l[y]]),l[y].push(P)):l[y]=P);return l},r.build=function(o){var a="",l=!1;return o.protocol&&(a+=o.protocol+":"),!o.urn&&(a||o.hostname)&&(a+="//",l=!0),a+=r.buildAuthority(o)||"",typeof o.path=="string"&&(o.path.charAt(0)!=="/"&&l&&(a+="/"),a+=o.path),typeof o.query=="string"&&o.query&&(a+="?"+o.query),typeof o.fragment=="string"&&o.fragment&&(a+="#"+o.fragment),a},r.buildHost=function(o){var a="";if(o.hostname)r.ip6_expression.test(o.hostname)?a+="["+o.hostname+"]":a+=o.hostname;else return"";return o.port&&(a+=":"+o.port),a},r.buildAuthority=function(o){return r.buildUserinfo(o)+r.buildHost(o)},r.buildUserinfo=function(o){var a="";return o.username&&(a+=r.encode(o.username)),o.password&&(a+=":"+r.encode(o.password)),a&&(a+="@"),a},r.buildQuery=function(o,a,l){var m="",_,v,y,P;for(v in o)if(v!=="__proto__"&&p.call(o,v))if(w(o[v]))for(_={},y=0,P=o[v].length;y<P;y++)o[v][y]!==void 0&&_[o[v][y]+""]===void 0&&(m+="&"+r.buildQueryParameter(v,o[v][y],l),a!==!0&&(_[o[v][y]+""]=!0));else o[v]!==void 0&&(m+="&"+r.buildQueryParameter(v,o[v],l));return m.substring(1)},r.buildQueryParameter=function(o,a,l){return r.encodeQuery(o,l)+(a!==null?"="+r.encodeQuery(a,l):"")},r.addQuery=function(o,a,l){if(typeof a=="object")for(var m in a)p.call(a,m)&&r.addQuery(o,m,a[m]);else if(typeof a=="string"){if(o[a]===void 0){o[a]=l;return}else typeof o[a]=="string"&&(o[a]=[o[a]]);w(l)||(l=[l]),o[a]=(o[a]||[]).concat(l)}else throw new TypeError("URI.addQuery() accepts an object, string as the name parameter")},r.setQuery=function(o,a,l){if(typeof a=="object")for(var m in a)p.call(a,m)&&r.setQuery(o,m,a[m]);else if(typeof a=="string")o[a]=l===void 0?null:l;else throw new TypeError("URI.setQuery() accepts an object, string as the name parameter")},r.removeQuery=function(o,a,l){var m,_,v;if(w(a))for(m=0,_=a.length;m<_;m++)o[a[m]]=void 0;else if(g(a)==="RegExp")for(v in o)a.test(v)&&(o[v]=void 0);else if(typeof a=="object")for(v in a)p.call(a,v)&&r.removeQuery(o,v,a[v]);else if(typeof a=="string")l!==void 0?g(l)==="RegExp"?!w(o[a])&&l.test(o[a])?o[a]=void 0:o[a]=x(o[a],l):o[a]===String(l)&&(!w(l)||l.length===1)?o[a]=void 0:w(o[a])&&(o[a]=x(o[a],l)):o[a]=void 0;else throw new TypeError("URI.removeQuery() accepts an object, string, RegExp as the first parameter")},r.hasQuery=function(o,a,l,m){switch(g(a)){case"String":break;case"RegExp":for(var _ in o)if(p.call(o,_)&&a.test(_)&&(l===void 0||r.hasQuery(o,_,l)))return!0;return!1;case"Object":for(var v in a)if(p.call(a,v)&&!r.hasQuery(o,v,a[v]))return!1;return!0;default:throw new TypeError("URI.hasQuery() accepts a string, regular expression or object as the name parameter")}switch(g(l)){case"Undefined":return a in o;case"Boolean":var y=!!(w(o[a])?o[a].length:o[a]);return l===y;case"Function":return!!l(o[a],a,o);case"Array":if(!w(o[a]))return!1;var P=m?R:I;return P(o[a],l);case"RegExp":return w(o[a])?m?R(o[a],l):!1:!!(o[a]&&o[a].match(l));case"Number":l=String(l);case"String":return w(o[a])?m?R(o[a],l):!1:o[a]===l;default:throw new TypeError("URI.hasQuery() accepts undefined, boolean, string, number, RegExp, Function as the value parameter")}},r.joinPaths=function(){for(var o=[],a=[],l=0,m=0;m<arguments.length;m++){var _=new r(arguments[m]);o.push(_);for(var v=_.segment(),y=0;y<v.length;y++)typeof v[y]=="string"&&a.push(v[y]),v[y]&&l++}if(!a.length||!l)return new r("");var P=new r("").segment(a);return(o[0].path()===""||o[0].path().slice(0,1)==="/")&&P.path("/"+P.path()),P.normalize()},r.commonPath=function(o,a){var l=Math.min(o.length,a.length),m;for(m=0;m<l;m++)if(o.charAt(m)!==a.charAt(m)){m--;break}return m<1?o.charAt(0)===a.charAt(0)&&o.charAt(0)==="/"?"/":"":((o.charAt(m)!=="/"||a.charAt(m)!=="/")&&(m=o.substring(0,m).lastIndexOf("/")),o.substring(0,m+1))},r.withinString=function(o,a,l){l||(l={});var m=l.start||r.findUri.start,_=l.end||r.findUri.end,v=l.trim||r.findUri.trim,y=l.parens||r.findUri.parens,P=/[a-z0-9-]=["']?$/i;for(m.lastIndex=0;;){var z=m.exec(o);if(!z)break;var V=z.index;if(l.ignoreHtml){var ne=o.slice(Math.max(V-3,0),V);if(ne&&P.test(ne))continue}for(var se=V+o.slice(V).search(_),G=o.slice(V,se),ae=-1;;){var he=y.exec(G);if(!he)break;var be=he.index+he[0].length;ae=Math.max(ae,be)}if(ae>-1?G=G.slice(0,ae)+G.slice(ae).replace(v,""):G=G.replace(v,""),!(G.length<=z[0].length)&&!(l.ignore&&l.ignore.test(G))){se=V+G.length;var ye=a(G,V,se,o);if(ye===void 0){m.lastIndex=se;continue}ye=String(ye),o=o.slice(0,V)+ye+o.slice(se),m.lastIndex=V+ye.length}}return m.lastIndex=0,o},r.ensureValidHostname=function(o,a){var l=!!o,m=!!a,_=!1;if(m&&(_=R(r.hostProtocols,a)),_&&!l)throw new TypeError("Hostname cannot be empty, if protocol is "+a);if(o&&o.match(r.invalid_hostname_characters)){if(!e)throw new TypeError('Hostname "'+o+'" contains characters other than [A-Z0-9.-:_] and Punycode.js is not available');if(e.toASCII(o).match(r.invalid_hostname_characters))throw new TypeError('Hostname "'+o+'" contains characters other than [A-Z0-9.-:_]')}},r.ensureValidPort=function(o){if(o){var a=Number(o);if(!(c(a)&&a>0&&a<65536))throw new TypeError('Port "'+o+'" is not a valid port')}},r.noConflict=function(o){if(o){var a={URI:this.noConflict()};return i.URITemplate&&typeof i.URITemplate.noConflict=="function"&&(a.URITemplate=i.URITemplate.noConflict()),i.IPv6&&typeof i.IPv6.noConflict=="function"&&(a.IPv6=i.IPv6.noConflict()),i.SecondLevelDomains&&typeof i.SecondLevelDomains.noConflict=="function"&&(a.SecondLevelDomains=i.SecondLevelDomains.noConflict()),a}else i.URI===this&&(i.URI=s);return this},u.build=function(o){return o===!0?this._deferred_build=!0:(o===void 0||this._deferred_build)&&(this._string=r.build(this._parts),this._deferred_build=!1),this},u.clone=function(){return new r(this)},u.valueOf=u.toString=function(){return this.build(!1)._string};function H(o){return function(a,l){return a===void 0?this._parts[o]||"":(this._parts[o]=a||null,this.build(!l),this)}}function oe(o,a){return function(l,m){return l===void 0?this._parts[o]||"":(l!==null&&(l=l+"",l.charAt(0)===a&&(l=l.substring(1))),this._parts[o]=l,this.build(!m),this)}}u.protocol=H("protocol"),u.username=H("username"),u.password=H("password"),u.hostname=H("hostname"),u.port=H("port"),u.query=oe("query","?"),u.fragment=oe("fragment","#"),u.search=function(o,a){var l=this.query(o,a);return typeof l=="string"&&l.length?"?"+l:l},u.hash=function(o,a){var l=this.fragment(o,a);return typeof l=="string"&&l.length?"#"+l:l},u.pathname=function(o,a){if(o===void 0||o===!0){var l=this._parts.path||(this._parts.hostname?"/":"");return o?(this._parts.urn?r.decodeUrnPath:r.decodePath)(l):l}else return this._parts.urn?this._parts.path=o?r.recodeUrnPath(o):"":this._parts.path=o?r.recodePath(o):"/",this.build(!a),this},u.path=u.pathname,u.href=function(o,a){var l;if(o===void 0)return this.toString();this._string="",this._parts=r._parts();var m=o instanceof r,_=typeof o=="object"&&(o.hostname||o.path||o.pathname);if(o.nodeName){var v=r.getDomAttribute(o);o=o[v]||"",_=!1}if(!m&&_&&o.pathname!==void 0&&(o=o.toString()),typeof o=="string"||o instanceof String)this._parts=r.parse(String(o),this._parts);else if(m||_){var y=m?o._parts:o;for(l in y)l!=="query"&&p.call(this._parts,l)&&(this._parts[l]=y[l]);y.query&&this.query(y.query,!1)}else throw new TypeError("invalid input");return this.build(!a),this},u.is=function(o){var a=!1,l=!1,m=!1,_=!1,v=!1,y=!1,P=!1,z=!this._parts.urn;switch(this._parts.hostname&&(z=!1,l=r.ip4_expression.test(this._parts.hostname),m=r.ip6_expression.test(this._parts.hostname),a=l||m,_=!a,v=_&&n&&n.has(this._parts.hostname),y=_&&r.idn_expression.test(this._parts.hostname),P=_&&r.punycode_expression.test(this._parts.hostname)),o.toLowerCase()){case"relative":return z;case"absolute":return!z;case"domain":case"name":return _;case"sld":return v;case"ip":return a;case"ip4":case"ipv4":case"inet4":return l;case"ip6":case"ipv6":case"inet6":return m;case"idn":return y;case"url":return!this._parts.urn;case"urn":return!!this._parts.urn;case"punycode":return P}return null};var ie=u.protocol,J=u.port,W=u.hostname;u.protocol=function(o,a){if(o&&(o=o.replace(/:(\/\/)?$/,""),!o.match(r.protocol_expression)))throw new TypeError('Protocol "'+o+`" contains characters other than [A-Z0-9.+-] or doesn't start with [A-Z]`);return ie.call(this,o,a)},u.scheme=u.protocol,u.port=function(o,a){return this._parts.urn?o===void 0?"":this:(o!==void 0&&(o===0&&(o=null),o&&(o+="",o.charAt(0)===":"&&(o=o.substring(1)),r.ensureValidPort(o))),J.call(this,o,a))},u.hostname=function(o,a){if(this._parts.urn)return o===void 0?"":this;if(o!==void 0){var l={preventInvalidHostname:this._parts.preventInvalidHostname},m=r.parseHost(o,l);if(m!=="/")throw new TypeError('Hostname "'+o+'" contains characters other than [A-Z0-9.-]');o=l.hostname,this._parts.preventInvalidHostname&&r.ensureValidHostname(o,this._parts.protocol)}return W.call(this,o,a)},u.origin=function(o,a){if(this._parts.urn)return o===void 0?"":this;if(o===void 0){var l=this.protocol(),m=this.authority();return m?(l?l+"://":"")+this.authority():""}else{var _=r(o);return this.protocol(_.protocol()).authority(_.authority()).build(!a),this}},u.host=function(o,a){if(this._parts.urn)return o===void 0?"":this;if(o===void 0)return this._parts.hostname?r.buildHost(this._parts):"";var l=r.parseHost(o,this._parts);if(l!=="/")throw new TypeError('Hostname "'+o+'" contains characters other than [A-Z0-9.-]');return this.build(!a),this},u.authority=function(o,a){if(this._parts.urn)return o===void 0?"":this;if(o===void 0)return this._parts.hostname?r.buildAuthority(this._parts):"";var l=r.parseAuthority(o,this._parts);if(l!=="/")throw new TypeError('Hostname "'+o+'" contains characters other than [A-Z0-9.-]');return this.build(!a),this},u.userinfo=function(o,a){if(this._parts.urn)return o===void 0?"":this;if(o===void 0){var l=r.buildUserinfo(this._parts);return l&&l.substring(0,l.length-1)}else return o[o.length-1]!=="@"&&(o+="@"),r.parseUserinfo(o,this._parts),this.build(!a),this},u.resource=function(o,a){var l;return o===void 0?this.path()+this.search()+this.hash():(l=r.parse(o),this._parts.path=l.path,this._parts.query=l.query,this._parts.fragment=l.fragment,this.build(!a),this)},u.subdomain=function(o,a){if(this._parts.urn)return o===void 0?"":this;if(o===void 0){if(!this._parts.hostname||this.is("IP"))return"";var l=this._parts.hostname.length-this.domain().length-1;return this._parts.hostname.substring(0,l)||""}else{var m=this._parts.hostname.length-this.domain().length,_=this._parts.hostname.substring(0,m),v=new RegExp("^"+b(_));if(o&&o.charAt(o.length-1)!=="."&&(o+="."),o.indexOf(":")!==-1)throw new TypeError("Domains cannot contain colons");return o&&r.ensureValidHostname(o,this._parts.protocol),this._parts.hostname=this._parts.hostname.replace(v,o),this.build(!a),this}},u.domain=function(o,a){if(this._parts.urn)return o===void 0?"":this;if(typeof o=="boolean"&&(a=o,o=void 0),o===void 0){if(!this._parts.hostname||this.is("IP"))return"";var l=this._parts.hostname.match(/\./g);if(l&&l.length<2)return this._parts.hostname;var m=this._parts.hostname.length-this.tld(a).length-1;return m=this._parts.hostname.lastIndexOf(".",m-1)+1,this._parts.hostname.substring(m)||""}else{if(!o)throw new TypeError("cannot set domain empty");if(o.indexOf(":")!==-1)throw new TypeError("Domains cannot contain colons");if(r.ensureValidHostname(o,this._parts.protocol),!this._parts.hostname||this.is("IP"))this._parts.hostname=o;else{var _=new RegExp(b(this.domain())+"$");this._parts.hostname=this._parts.hostname.replace(_,o)}return this.build(!a),this}},u.tld=function(o,a){if(this._parts.urn)return o===void 0?"":this;if(typeof o=="boolean"&&(a=o,o=void 0),o===void 0){if(!this._parts.hostname||this.is("IP"))return"";var l=this._parts.hostname.lastIndexOf("."),m=this._parts.hostname.substring(l+1);return a!==!0&&n&&n.list[m.toLowerCase()]&&n.get(this._parts.hostname)||m}else{var _;if(o)if(o.match(/[^a-zA-Z0-9-]/))if(n&&n.is(o))_=new RegExp(b(this.tld())+"$"),this._parts.hostname=this._parts.hostname.replace(_,o);else throw new TypeError('TLD "'+o+'" contains characters other than [A-Z0-9]');else{if(!this._parts.hostname||this.is("IP"))throw new ReferenceError("cannot set TLD on non-domain host");_=new RegExp(b(this.tld())+"$"),this._parts.hostname=this._parts.hostname.replace(_,o)}else throw new TypeError("cannot set TLD empty");return this.build(!a),this}},u.directory=function(o,a){if(this._parts.urn)return o===void 0?"":this;if(o===void 0||o===!0){if(!this._parts.path&&!this._parts.hostname)return"";if(this._parts.path==="/")return"/";var l=this._parts.path.length-this.filename().length-1,m=this._parts.path.substring(0,l)||(this._parts.hostname?"/":"");return o?r.decodePath(m):m}else{var _=this._parts.path.length-this.filename().length,v=this._parts.path.substring(0,_),y=new RegExp("^"+b(v));return this.is("relative")||(o||(o="/"),o.charAt(0)!=="/"&&(o="/"+o)),o&&o.charAt(o.length-1)!=="/"&&(o+="/"),o=r.recodePath(o),this._parts.path=this._parts.path.replace(y,o),this.build(!a),this}},u.filename=function(o,a){if(this._parts.urn)return o===void 0?"":this;if(typeof o!="string"){if(!this._parts.path||this._parts.path==="/")return"";var l=this._parts.path.lastIndexOf("/"),m=this._parts.path.substring(l+1);return o?r.decodePathSegment(m):m}else{var _=!1;o.charAt(0)==="/"&&(o=o.substring(1)),o.match(/\.?\//)&&(_=!0);var v=new RegExp(b(this.filename())+"$");return o=r.recodePath(o),this._parts.path=this._parts.path.replace(v,o),_?this.normalizePath(a):this.build(!a),this}},u.suffix=function(o,a){if(this._parts.urn)return o===void 0?"":this;if(o===void 0||o===!0){if(!this._parts.path||this._parts.path==="/")return"";var l=this.filename(),m=l.lastIndexOf("."),_,v;return m===-1?"":(_=l.substring(m+1),v=/^[a-z0-9%]+$/i.test(_)?_:"",o?r.decodePathSegment(v):v)}else{o.charAt(0)==="."&&(o=o.substring(1));var y=this.suffix(),P;if(y)o?P=new RegExp(b(y)+"$"):P=new RegExp(b("."+y)+"$");else{if(!o)return this;this._parts.path+="."+r.recodePath(o)}return P&&(o=r.recodePath(o),this._parts.path=this._parts.path.replace(P,o)),this.build(!a),this}},u.segment=function(o,a,l){var m=this._parts.urn?":":"/",_=this.path(),v=_.substring(0,1)==="/",y=_.split(m);if(o!==void 0&&typeof o!="number"&&(l=a,a=o,o=void 0),o!==void 0&&typeof o!="number")throw new Error('Bad segment "'+o+'", must be 0-based integer');if(v&&y.shift(),o<0&&(o=Math.max(y.length+o,0)),a===void 0)return o===void 0?y:y[o];if(o===null||y[o]===void 0)if(w(a)){y=[];for(var P=0,z=a.length;P<z;P++)!a[P].length&&(!y.length||!y[y.length-1].length)||(y.length&&!y[y.length-1].length&&y.pop(),y.push(T(a[P])))}else(a||typeof a=="string")&&(a=T(a),y[y.length-1]===""?y[y.length-1]=a:y.push(a));else a?y[o]=T(a):y.splice(o,1);return v&&y.unshift(""),this.path(y.join(m),l)},u.segmentCoded=function(o,a,l){var m,_,v;if(typeof o!="number"&&(l=a,a=o,o=void 0),a===void 0){if(m=this.segment(o,a,l),!w(m))m=m!==void 0?r.decode(m):void 0;else for(_=0,v=m.length;_<v;_++)m[_]=r.decode(m[_]);return m}if(!w(a))a=typeof a=="string"||a instanceof String?r.encode(a):a;else for(_=0,v=a.length;_<v;_++)a[_]=r.encode(a[_]);return this.segment(o,a,l)};var Q=u.query;return u.query=function(o,a){if(o===!0)return r.parseQuery(this._parts.query,this._parts.escapeQuerySpace);if(typeof o=="function"){var l=r.parseQuery(this._parts.query,this._parts.escapeQuerySpace),m=o.call(this,l);return this._parts.query=r.buildQuery(m||l,this._parts.duplicateQueryParameters,this._parts.escapeQuerySpace),this.build(!a),this}else return o!==void 0&&typeof o!="string"?(this._parts.query=r.buildQuery(o,this._parts.duplicateQueryParameters,this._parts.escapeQuerySpace),this.build(!a),this):Q.call(this,o,a)},u.setQuery=function(o,a,l){var m=r.parseQuery(this._parts.query,this._parts.escapeQuerySpace);if(typeof o=="string"||o instanceof String)m[o]=a!==void 0?a:null;else if(typeof o=="object")for(var _ in o)p.call(o,_)&&(m[_]=o[_]);else throw new TypeError("URI.addQuery() accepts an object, string as the name parameter");return this._parts.query=r.buildQuery(m,this._parts.duplicateQueryParameters,this._parts.escapeQuerySpace),typeof o!="string"&&(l=a),this.build(!l),this},u.addQuery=function(o,a,l){var m=r.parseQuery(this._parts.query,this._parts.escapeQuerySpace);return r.addQuery(m,o,a===void 0?null:a),this._parts.query=r.buildQuery(m,this._parts.duplicateQueryParameters,this._parts.escapeQuerySpace),typeof o!="string"&&(l=a),this.build(!l),this},u.removeQuery=function(o,a,l){var m=r.parseQuery(this._parts.query,this._parts.escapeQuerySpace);return r.removeQuery(m,o,a),this._parts.query=r.buildQuery(m,this._parts.duplicateQueryParameters,this._parts.escapeQuerySpace),typeof o!="string"&&(l=a),this.build(!l),this},u.hasQuery=function(o,a,l){var m=r.parseQuery(this._parts.query,this._parts.escapeQuerySpace);return r.hasQuery(m,o,a,l)},u.setSearch=u.setQuery,u.addSearch=u.addQuery,u.removeSearch=u.removeQuery,u.hasSearch=u.hasQuery,u.normalize=function(){return this._parts.urn?this.normalizeProtocol(!1).normalizePath(!1).normalizeQuery(!1).normalizeFragment(!1).build():this.normalizeProtocol(!1).normalizeHostname(!1).normalizePort(!1).normalizePath(!1).normalizeQuery(!1).normalizeFragment(!1).build()},u.normalizeProtocol=function(o){return typeof this._parts.protocol=="string"&&(this._parts.protocol=this._parts.protocol.toLowerCase(),this.build(!o)),this},u.normalizeHostname=function(o){return this._parts.hostname&&(this.is("IDN")&&e?this._parts.hostname=e.toASCII(this._parts.hostname):this.is("IPv6")&&t&&(this._parts.hostname=t.best(this._parts.hostname)),this._parts.hostname=this._parts.hostname.toLowerCase(),this.build(!o)),this},u.normalizePort=function(o){return typeof this._parts.protocol=="string"&&this._parts.port===r.defaultPorts[this._parts.protocol]&&(this._parts.port=null,this.build(!o)),this},u.normalizePath=function(o){var a=this._parts.path;if(!a)return this;if(this._parts.urn)return this._parts.path=r.recodeUrnPath(this._parts.path),this.build(!o),this;if(this._parts.path==="/")return this;a=r.recodePath(a);var l,m="",_,v;for(a.charAt(0)!=="/"&&(l=!0,a="/"+a),(a.slice(-3)==="/.."||a.slice(-2)==="/.")&&(a+="/"),a=a.replace(/(\/(\.\/)+)|(\/\.$)/g,"/").replace(/\/{2,}/g,"/"),l&&(m=a.substring(1).match(/^(\.\.\/)+/)||"",m&&(m=m[0]));_=a.search(/\/\.\.(\/|$)/),_!==-1;){if(_===0){a=a.substring(3);continue}v=a.substring(0,_).lastIndexOf("/"),v===-1&&(v=_),a=a.substring(0,v)+a.substring(_+3)}return l&&this.is("relative")&&(a=m+a.substring(1)),this._parts.path=a,this.build(!o),this},u.normalizePathname=u.normalizePath,u.normalizeQuery=function(o){return typeof this._parts.query=="string"&&(this._parts.query.length?this.query(r.parseQuery(this._parts.query,this._parts.escapeQuerySpace)):this._parts.query=null,this.build(!o)),this},u.normalizeFragment=function(o){return this._parts.fragment||(this._parts.fragment=null,this.build(!o)),this},u.normalizeSearch=u.normalizeQuery,u.normalizeHash=u.normalizeFragment,u.iso8859=function(){var o=r.encode,a=r.decode;r.encode=escape,r.decode=decodeURIComponent;try{this.normalize()}finally{r.encode=o,r.decode=a}return this},u.unicode=function(){var o=r.encode,a=r.decode;r.encode=U,r.decode=unescape;try{this.normalize()}finally{r.encode=o,r.decode=a}return this},u.readable=function(){var o=this.clone();o.username("").password("").normalize();var a="";if(o._parts.protocol&&(a+=o._parts.protocol+"://"),o._parts.hostname&&(o.is("punycode")&&e?(a+=e.toUnicode(o._parts.hostname),o._parts.port&&(a+=":"+o._parts.port)):a+=o.host()),o._parts.hostname&&o._parts.path&&o._parts.path.charAt(0)!=="/"&&(a+="/"),a+=o.path(!0),o._parts.query){for(var l="",m=0,_=o._parts.query.split("&"),v=_.length;m<v;m++){var y=(_[m]||"").split("=");l+="&"+r.decodeQuery(y[0],this._parts.escapeQuerySpace).replace(/&/g,"%26"),y[1]!==void 0&&(l+="="+r.decodeQuery(y[1],this._parts.escapeQuerySpace).replace(/&/g,"%26"))}a+="?"+l.substring(1)}return a+=r.decodeQuery(o.hash(),!0),a},u.absoluteTo=function(o){var a=this.clone(),l=["protocol","username","password","hostname","port"],m,_,v;if(this._parts.urn)throw new Error("URNs do not have any generally defined hierarchical components");if(o instanceof r||(o=new r(o)),a._parts.protocol||(a._parts.protocol=o._parts.protocol,this._parts.hostname))return a;for(_=0;v=l[_];_++)a._parts[v]=o._parts[v];return a._parts.path?(a._parts.path.substring(-2)===".."&&(a._parts.path+="/"),a.path().charAt(0)!=="/"&&(m=o.directory(),m=m||(o.path().indexOf("/")===0?"/":""),a._parts.path=(m?m+"/":"")+a._parts.path,a.normalizePath())):(a._parts.path=o._parts.path,a._parts.query||(a._parts.query=o._parts.query)),a.build(),a},u.relativeTo=function(o){var a=this.clone().normalize(),l,m,_,v,y;if(a._parts.urn)throw new Error("URNs do not have any generally defined hierarchical components");if(o=new r(o).normalize(),l=a._parts,m=o._parts,v=a.path(),y=o.path(),v.charAt(0)!=="/")throw new Error("URI is already relative");if(y.charAt(0)!=="/")throw new Error("Cannot calculate a URI relative to another relative URI");if(l.protocol===m.protocol&&(l.protocol=null),l.username!==m.username||l.password!==m.password||l.protocol!==null||l.username!==null||l.password!==null)return a.build();if(l.hostname===m.hostname&&l.port===m.port)l.hostname=null,l.port=null;else return a.build();if(v===y)return l.path="",a.build();if(_=r.commonPath(v,y),!_)return a.build();var P=m.path.substring(_.length).replace(/[^\/]*$/,"").replace(/.*?\//g,"../");return l.path=P+l.path.substring(_.length)||"./",a.build()},u.equals=function(o){var a=this.clone(),l=new r(o),m={},_={},v={},y,P,z;if(a.normalize(),l.normalize(),a.toString()===l.toString())return!0;if(y=a.query(),P=l.query(),a.query(""),l.query(""),a.toString()!==l.toString()||y.length!==P.length)return!1;m=r.parseQuery(y,this._parts.escapeQuerySpace),_=r.parseQuery(P,this._parts.escapeQuerySpace);for(z in m)if(p.call(m,z)){if(w(m[z])){if(!I(m[z],_[z]))return!1}else if(m[z]!==_[z])return!1;v[z]=!0}for(z in _)if(p.call(_,z)&&!v[z])return!1;return!0},u.preventInvalidHostname=function(o){return this._parts.preventInvalidHostname=!!o,this},u.duplicateQueryParameters=function(o){return this._parts.duplicateQueryParameters=!!o,this},u.escapeQuerySpace=function(o){return this._parts.escapeQuerySpace=!!o,this},r})});function Et(e){this._ellipsoid=O(e,qe.WGS84),this._semimajorAxis=this._ellipsoid.maximumRadius,this._oneOverSemimajorAxis=1/this._semimajorAxis}Object.defineProperties(Et.prototype,{ellipsoid:{get:function(){return this._ellipsoid}}});Et.prototype.project=function(e,t){let n=this._semimajorAxis,i=e.longitude*n,s=e.latitude*n,r=e.height;return d(t)?(t.x=i,t.y=s,t.z=r,t):new f(i,s,r)};Et.prototype.unproject=function(e,t){if(!d(e))throw new A("cartesian is required");let n=this._oneOverSemimajorAxis,i=e.x*n,s=e.y*n,r=e.z;return d(t)?(t.longitude=i,t.latitude=s,t.height=r,t):new De(i,s,r)};var cn=Et;var mo={OUTSIDE:-1,INTERSECTING:0,INSIDE:1},Ct=Object.freeze(mo);function ho(e,t){this.start=O(e,0),this.stop=O(t,0)}var er=ho;function D(e,t){this.center=f.clone(O(e,f.ZERO)),this.radius=O(t,0)}var ln=new f,dn=new f,pn=new f,mn=new f,hn=new f,yn=new f,gn=new f,ce=new f,wn=new f,bn=new f,_n=new f,xn=new f,yo=4/3*X.PI;D.fromPoints=function(e,t){if(d(t)||(t=new D),!d(e)||e.length===0)return t.center=f.clone(f.ZERO,t.center),t.radius=0,t;let n=f.clone(e[0],gn),i=f.clone(n,ln),s=f.clone(n,dn),r=f.clone(n,pn),c=f.clone(n,mn),u=f.clone(n,hn),p=f.clone(n,yn),b=e.length,g;for(g=1;g<b;g++){f.clone(e[g],n);let ie=n.x,J=n.y,W=n.z;ie<i.x&&f.clone(n,i),ie>c.x&&f.clone(n,c),J<s.y&&f.clone(n,s),J>u.y&&f.clone(n,u),W<r.z&&f.clone(n,r),W>p.z&&f.clone(n,p)}let w=f.magnitudeSquared(f.subtract(c,i,ce)),x=f.magnitudeSquared(f.subtract(u,s,ce)),R=f.magnitudeSquared(f.subtract(p,r,ce)),I=i,T=c,M=w;x>M&&(M=x,I=s,T=u),R>M&&(M=R,I=r,T=p);let U=wn;U.x=(I.x+T.x)*.5,U.y=(I.y+T.y)*.5,U.z=(I.z+T.z)*.5;let k=f.magnitudeSquared(f.subtract(T,U,ce)),q=Math.sqrt(k),F=bn;F.x=i.x,F.y=s.y,F.z=r.z;let j=_n;j.x=c.x,j.y=u.y,j.z=p.z;let H=f.midpoint(F,j,xn),oe=0;for(g=0;g<b;g++){f.clone(e[g],n);let ie=f.magnitude(f.subtract(n,H,ce));ie>oe&&(oe=ie);let J=f.magnitudeSquared(f.subtract(n,U,ce));if(J>k){let W=Math.sqrt(J);q=(q+W)*.5,k=q*q;let Q=W-q;U.x=(q*U.x+Q*n.x)/W,U.y=(q*U.y+Q*n.y)/W,U.z=(q*U.z+Q*n.z)/W}}return q<oe?(f.clone(U,t.center),t.radius=q):(f.clone(H,t.center),t.radius=oe),t};var go=new cn,wo=new f,bo=new f,un=new De,fn=new De;D.fromRectangle2D=function(e,t,n){return D.fromRectangleWithHeights2D(e,t,0,0,n)};D.fromRectangleWithHeights2D=function(e,t,n,i,s){if(d(s)||(s=new D),!d(e))return s.center=f.clone(f.ZERO,s.center),s.radius=0,s;t=O(t,go),vt.southwest(e,un),un.height=n,vt.northeast(e,fn),fn.height=i;let r=t.project(un,wo),c=t.project(fn,bo),u=c.x-r.x,p=c.y-r.y,b=c.z-r.z;s.radius=Math.sqrt(u*u+p*p+b*b)*.5;let g=s.center;return g.x=r.x+u*.5,g.y=r.y+p*.5,g.z=r.z+b*.5,s};var _o=[];D.fromRectangle3D=function(e,t,n,i){if(t=O(t,qe.WGS84),n=O(n,0),d(i)||(i=new D),!d(e))return i.center=f.clone(f.ZERO,i.center),i.radius=0,i;let s=vt.subsample(e,t,n,_o);return D.fromPoints(s,i)};D.fromVertices=function(e,t,n,i){if(d(i)||(i=new D),!d(e)||e.length===0)return i.center=f.clone(f.ZERO,i.center),i.radius=0,i;t=O(t,f.ZERO),n=O(n,3),h.typeOf.number.greaterThanOrEquals("stride",n,3);let s=gn;s.x=e[0]+t.x,s.y=e[1]+t.y,s.z=e[2]+t.z;let r=f.clone(s,ln),c=f.clone(s,dn),u=f.clone(s,pn),p=f.clone(s,mn),b=f.clone(s,hn),g=f.clone(s,yn),w=e.length,x;for(x=0;x<w;x+=n){let W=e[x]+t.x,Q=e[x+1]+t.y,o=e[x+2]+t.z;s.x=W,s.y=Q,s.z=o,W<r.x&&f.clone(s,r),W>p.x&&f.clone(s,p),Q<c.y&&f.clone(s,c),Q>b.y&&f.clone(s,b),o<u.z&&f.clone(s,u),o>g.z&&f.clone(s,g)}let R=f.magnitudeSquared(f.subtract(p,r,ce)),I=f.magnitudeSquared(f.subtract(b,c,ce)),T=f.magnitudeSquared(f.subtract(g,u,ce)),M=r,U=p,k=R;I>k&&(k=I,M=c,U=b),T>k&&(k=T,M=u,U=g);let q=wn;q.x=(M.x+U.x)*.5,q.y=(M.y+U.y)*.5,q.z=(M.z+U.z)*.5;let F=f.magnitudeSquared(f.subtract(U,q,ce)),j=Math.sqrt(F),H=bn;H.x=r.x,H.y=c.y,H.z=u.z;let oe=_n;oe.x=p.x,oe.y=b.y,oe.z=g.z;let ie=f.midpoint(H,oe,xn),J=0;for(x=0;x<w;x+=n){s.x=e[x]+t.x,s.y=e[x+1]+t.y,s.z=e[x+2]+t.z;let W=f.magnitude(f.subtract(s,ie,ce));W>J&&(J=W);let Q=f.magnitudeSquared(f.subtract(s,q,ce));if(Q>F){let o=Math.sqrt(Q);j=(j+o)*.5,F=j*j;let a=o-j;q.x=(j*q.x+a*s.x)/o,q.y=(j*q.y+a*s.y)/o,q.z=(j*q.z+a*s.z)/o}}return j<J?(f.clone(q,i.center),i.radius=j):(f.clone(ie,i.center),i.radius=J),i};D.fromEncodedCartesianVertices=function(e,t,n){if(d(n)||(n=new D),!d(e)||!d(t)||e.length!==t.length||e.length===0)return n.center=f.clone(f.ZERO,n.center),n.radius=0,n;let i=gn;i.x=e[0]+t[0],i.y=e[1]+t[1],i.z=e[2]+t[2];let s=f.clone(i,ln),r=f.clone(i,dn),c=f.clone(i,pn),u=f.clone(i,mn),p=f.clone(i,hn),b=f.clone(i,yn),g=e.length,w;for(w=0;w<g;w+=3){let J=e[w]+t[w],W=e[w+1]+t[w+1],Q=e[w+2]+t[w+2];i.x=J,i.y=W,i.z=Q,J<s.x&&f.clone(i,s),J>u.x&&f.clone(i,u),W<r.y&&f.clone(i,r),W>p.y&&f.clone(i,p),Q<c.z&&f.clone(i,c),Q>b.z&&f.clone(i,b)}let x=f.magnitudeSquared(f.subtract(u,s,ce)),R=f.magnitudeSquared(f.subtract(p,r,ce)),I=f.magnitudeSquared(f.subtract(b,c,ce)),T=s,M=u,U=x;R>U&&(U=R,T=r,M=p),I>U&&(U=I,T=c,M=b);let k=wn;k.x=(T.x+M.x)*.5,k.y=(T.y+M.y)*.5,k.z=(T.z+M.z)*.5;let q=f.magnitudeSquared(f.subtract(M,k,ce)),F=Math.sqrt(q),j=bn;j.x=s.x,j.y=r.y,j.z=c.z;let H=_n;H.x=u.x,H.y=p.y,H.z=b.z;let oe=f.midpoint(j,H,xn),ie=0;for(w=0;w<g;w+=3){i.x=e[w]+t[w],i.y=e[w+1]+t[w+1],i.z=e[w+2]+t[w+2];let J=f.magnitude(f.subtract(i,oe,ce));J>ie&&(ie=J);let W=f.magnitudeSquared(f.subtract(i,k,ce));if(W>q){let Q=Math.sqrt(W);F=(F+Q)*.5,q=F*F;let o=Q-F;k.x=(F*k.x+o*i.x)/Q,k.y=(F*k.y+o*i.y)/Q,k.z=(F*k.z+o*i.z)/Q}}return F<ie?(f.clone(k,n.center),n.radius=F):(f.clone(oe,n.center),n.radius=ie),n};D.fromCornerPoints=function(e,t,n){h.typeOf.object("corner",e),h.typeOf.object("oppositeCorner",t),d(n)||(n=new D);let i=f.midpoint(e,t,n.center);return n.radius=f.distance(i,t),n};D.fromEllipsoid=function(e,t){return h.typeOf.object("ellipsoid",e),d(t)||(t=new D),f.clone(f.ZERO,t.center),t.radius=e.maximumRadius,t};var xo=new f;D.fromBoundingSpheres=function(e,t){if(d(t)||(t=new D),!d(e)||e.length===0)return t.center=f.clone(f.ZERO,t.center),t.radius=0,t;let n=e.length;if(n===1)return D.clone(e[0],t);if(n===2)return D.union(e[0],e[1],t);let i=[],s;for(s=0;s<n;s++)i.push(e[s].center);t=D.fromPoints(i,t);let r=t.center,c=t.radius;for(s=0;s<n;s++){let u=e[s];c=Math.max(c,f.distance(r,u.center,xo)+u.radius)}return t.radius=c,t};var So=new f,Oo=new f,vo=new f;D.fromOrientedBoundingBox=function(e,t){h.defined("orientedBoundingBox",e),d(t)||(t=new D);let n=e.halfAxes,i=B.getColumn(n,0,So),s=B.getColumn(n,1,Oo),r=B.getColumn(n,2,vo);return f.add(i,s,i),f.add(i,r,i),t.center=f.clone(e.center,t.center),t.radius=f.magnitude(i),t};var Eo=new f,Co=new f;D.fromTransformation=function(e,t){h.typeOf.object("transformation",e),d(t)||(t=new D);let n=L.getTranslation(e,Eo),i=L.getScale(e,Co),s=.5*f.magnitude(i);return t.center=f.clone(n,t.center),t.radius=s,t};D.clone=function(e,t){if(d(e))return d(t)?(t.center=f.clone(e.center,t.center),t.radius=e.radius,t):new D(e.center,e.radius)};D.packedLength=4;D.pack=function(e,t,n){h.typeOf.object("value",e),h.defined("array",t),n=O(n,0);let i=e.center;return t[n++]=i.x,t[n++]=i.y,t[n++]=i.z,t[n]=e.radius,t};D.unpack=function(e,t,n){h.defined("array",e),t=O(t,0),d(n)||(n=new D);let i=n.center;return i.x=e[t++],i.y=e[t++],i.z=e[t++],n.radius=e[t],n};var Ao=new f,Ro=new f;D.union=function(e,t,n){h.typeOf.object("left",e),h.typeOf.object("right",t),d(n)||(n=new D);let i=e.center,s=e.radius,r=t.center,c=t.radius,u=f.subtract(r,i,Ao),p=f.magnitude(u);if(s>=p+c)return e.clone(n),n;if(c>=p+s)return t.clone(n),n;let b=(s+p+c)*.5,g=f.multiplyByScalar(u,(-s+b)/p,Ro);return f.add(g,i,g),f.clone(g,n.center),n.radius=b,n};var Po=new f;D.expand=function(e,t,n){h.typeOf.object("sphere",e),h.typeOf.object("point",t),n=D.clone(e,n);let i=f.magnitude(f.subtract(t,n.center,Po));return i>n.radius&&(n.radius=i),n};D.intersectPlane=function(e,t){h.typeOf.object("sphere",e),h.typeOf.object("plane",t);let n=e.center,i=e.radius,s=t.normal,r=f.dot(s,n)+t.distance;return r<-i?Ct.OUTSIDE:r<i?Ct.INTERSECTING:Ct.INSIDE};D.transform=function(e,t,n){return h.typeOf.object("sphere",e),h.typeOf.object("transform",t),d(n)||(n=new D),n.center=L.multiplyByPoint(t,e.center,n.center),n.radius=L.getMaximumScale(t)*e.radius,n};var To=new f;D.distanceSquaredTo=function(e,t){h.typeOf.object("sphere",e),h.typeOf.object("cartesian",t);let n=f.subtract(e.center,t,To),i=f.magnitude(n)-e.radius;return i<=0?0:i*i};D.transformWithoutScale=function(e,t,n){return h.typeOf.object("sphere",e),h.typeOf.object("transform",t),d(n)||(n=new D),n.center=L.multiplyByPoint(t,e.center,n.center),n.radius=e.radius,n};var Io=new f;D.computePlaneDistances=function(e,t,n,i){h.typeOf.object("sphere",e),h.typeOf.object("position",t),h.typeOf.object("direction",n),d(i)||(i=new er);let s=f.subtract(e.center,t,Io),r=f.dot(n,s);return i.start=r-e.radius,i.stop=r+e.radius,i};var tr=new f,Uo=new f,Do=new f,qo=new f,zo=new f,Mo=new De,nr=new Array(8);for(let e=0;e<8;++e)nr[e]=new f;var ko=new cn;D.projectTo2D=function(e,t,n){h.typeOf.object("sphere",e),t=O(t,ko);let i=t.ellipsoid,s=e.center,r=e.radius,c;f.equals(s,f.ZERO)?c=f.clone(f.UNIT_X,tr):c=i.geodeticSurfaceNormal(s,tr);let u=f.cross(f.UNIT_Z,c,Uo);f.normalize(u,u);let p=f.cross(c,u,Do);f.normalize(p,p),f.multiplyByScalar(c,r,c),f.multiplyByScalar(p,r,p),f.multiplyByScalar(u,r,u);let b=f.negate(p,zo),g=f.negate(u,qo),w=nr,x=w[0];f.add(c,p,x),f.add(x,u,x),x=w[1],f.add(c,p,x),f.add(x,g,x),x=w[2],f.add(c,b,x),f.add(x,g,x),x=w[3],f.add(c,b,x),f.add(x,u,x),f.negate(c,c),x=w[4],f.add(c,p,x),f.add(x,u,x),x=w[5],f.add(c,p,x),f.add(x,g,x),x=w[6],f.add(c,b,x),f.add(x,g,x),x=w[7],f.add(c,b,x),f.add(x,u,x);let R=w.length;for(let U=0;U<R;++U){let k=w[U];f.add(s,k,k);let q=i.cartesianToCartographic(k,Mo);t.project(q,k)}n=D.fromPoints(w,n),s=n.center;let I=s.x,T=s.y,M=s.z;return s.x=M,s.y=I,s.z=T,n};D.isOccluded=function(e,t){return h.typeOf.object("sphere",e),h.typeOf.object("occluder",t),!t.isBoundingSphereVisible(e)};D.equals=function(e,t){return e===t||d(e)&&d(t)&&f.equals(e.center,t.center)&&e.radius===t.radius};D.prototype.intersectPlane=function(e){return D.intersectPlane(this,e)};D.prototype.distanceSquaredTo=function(e){return D.distanceSquaredTo(this,e)};D.prototype.computePlaneDistances=function(e,t,n){return D.computePlaneDistances(this,e,t,n)};D.prototype.isOccluded=function(e){return D.isOccluded(this,e)};D.prototype.equals=function(e){return D.equals(this,e)};D.prototype.clone=function(e){return D.clone(this,e)};D.prototype.volume=function(){let e=this.radius;return yo*e*e*e};var Qs=D;function Fo(e,t,n){h.defined("array",e),h.defined("itemToFind",t),h.defined("comparator",n);let i=0,s=e.length-1,r,c;for(;i<=s;){if(r=~~((i+s)/2),c=n(e[r],t),c<0){i=r+1;continue}if(c>0){s=r-1;continue}return r}return~(s+1)}var Qe=Fo;function jo(e,t,n,i,s){this.xPoleWander=e,this.yPoleWander=t,this.xPoleOffset=n,this.yPoleOffset=i,this.ut1MinusUtc=s}var ut=jo;function No(e){if(e===null||isNaN(e))throw new A("year is required and must be a number.");return e%4===0&&e%100!==0||e%400===0}var ft=No;var rr=[31,28,31,30,31,30,31,31,30,31,30,31];function Bo(e,t,n,i,s,r,c,u){e=O(e,1),t=O(t,1),n=O(n,1),i=O(i,0),s=O(s,0),r=O(r,0),c=O(c,0),u=O(u,!1),T(),M(),this.year=e,this.month=t,this.day=n,this.hour=i,this.minute=s,this.second=r,this.millisecond=c,this.isLeapSecond=u;function T(){h.typeOf.number.greaterThanOrEquals("Year",e,1),h.typeOf.number.lessThanOrEquals("Year",e,9999),h.typeOf.number.greaterThanOrEquals("Month",t,1),h.typeOf.number.lessThanOrEquals("Month",t,12),h.typeOf.number.greaterThanOrEquals("Day",n,1),h.typeOf.number.lessThanOrEquals("Day",n,31),h.typeOf.number.greaterThanOrEquals("Hour",i,0),h.typeOf.number.lessThanOrEquals("Hour",i,23),h.typeOf.number.greaterThanOrEquals("Minute",s,0),h.typeOf.number.lessThanOrEquals("Minute",s,59),h.typeOf.bool("IsLeapSecond",u),h.typeOf.number.greaterThanOrEquals("Second",r,0),h.typeOf.number.lessThanOrEquals("Second",r,u?60:59),h.typeOf.number.greaterThanOrEquals("Millisecond",c,0),h.typeOf.number.lessThan("Millisecond",c,1e3)}function M(){let U=t===2&&ft(e)?rr[t-1]+1:rr[t-1];if(n>U)throw new A("Month and Day represents invalid date")}}var At=Bo;function Lo(e,t){this.julianDate=e,this.offset=t}var Z=Lo;var Qo={SECONDS_PER_MILLISECOND:.001,SECONDS_PER_MINUTE:60,MINUTES_PER_HOUR:60,HOURS_PER_DAY:24,SECONDS_PER_HOUR:3600,MINUTES_PER_DAY:1440,SECONDS_PER_DAY:86400,DAYS_PER_JULIAN_CENTURY:36525,PICOSECOND:1e-9,MODIFIED_JULIAN_DATE_DIFFERENCE:24000005e-1},K=Object.freeze(Qo);var $o={UTC:0,TAI:1},N=Object.freeze($o);var ir=new At,Rt=[31,28,31,30,31,30,31,31,30,31,30,31],Pt=29;function Sn(e,t){return C.compare(e.julianDate,t.julianDate)}var Ke=new Z;function It(e){Ke.julianDate=e;let t=C.leapSeconds,n=Qe(t,Ke,Sn);n<0&&(n=~n),n>=t.length&&(n=t.length-1);let i=t[n].offset;n>0&&C.secondsDifference(t[n].julianDate,e)>i&&(n--,i=t[n].offset),C.addSeconds(e,i,e)}function or(e,t){Ke.julianDate=e;let n=C.leapSeconds,i=Qe(n,Ke,Sn);if(i<0&&(i=~i),i===0)return C.addSeconds(e,-n[0].offset,t);if(i>=n.length)return C.addSeconds(e,-n[i-1].offset,t);let s=C.secondsDifference(n[i].julianDate,e);if(s===0)return C.addSeconds(e,-n[i].offset,t);if(!(s<=1))return C.addSeconds(e,-n[--i].offset,t)}function Me(e,t,n){let i=t/K.SECONDS_PER_DAY|0;return e+=i,t-=K.SECONDS_PER_DAY*i,t<0&&(e--,t+=K.SECONDS_PER_DAY),n.dayNumber=e,n.secondsOfDay=t,n}function On(e,t,n,i,s,r,c){let u=(t-14)/12|0,p=e+4800+u,b=(1461*p/4|0)+(367*(t-2-12*u)/12|0)-(3*((p+100)/100|0)/4|0)+n-32075;i=i-12,i<0&&(i+=24);let g=r+(i*K.SECONDS_PER_HOUR+s*K.SECONDS_PER_MINUTE+c*K.SECONDS_PER_MILLISECOND);return g>=43200&&(b-=1),[b,g]}var Ho=/^(\d{4})$/,Wo=/^(\d{4})-(\d{2})$/,Vo=/^(\d{4})-?(\d{3})$/,Yo=/^(\d{4})-?W(\d{2})-?(\d{1})?$/,Zo=/^(\d{4})-?(\d{2})-?(\d{2})$/,vn=/([Z+\-])?(\d{2})?:?(\d{2})?$/,Xo=/^(\d{2})(\.\d+)?/.source+vn.source,Jo=/^(\d{2}):?(\d{2})(\.\d+)?/.source+vn.source,Go=/^(\d{2}):?(\d{2}):?(\d{2})(\.\d+)?/.source+vn.source,Oe="Invalid ISO 8601 date.";function C(e,t,n){this.dayNumber=void 0,this.secondsOfDay=void 0,e=O(e,0),t=O(t,0),n=O(n,N.UTC);let i=e|0;t=t+(e-i)*K.SECONDS_PER_DAY,Me(i,t,this),n===N.UTC&&It(this)}C.fromGregorianDate=function(e,t){if(!(e instanceof At))throw new A("date must be a valid GregorianDate.");let n=On(e.year,e.month,e.day,e.hour,e.minute,e.second,e.millisecond);return d(t)?(Me(n[0],n[1],t),It(t),t):new C(n[0],n[1],N.UTC)};C.fromDate=function(e,t){if(!(e instanceof Date)||isNaN(e.getTime()))throw new A("date must be a valid JavaScript Date.");let n=On(e.getUTCFullYear(),e.getUTCMonth()+1,e.getUTCDate(),e.getUTCHours(),e.getUTCMinutes(),e.getUTCSeconds(),e.getUTCMilliseconds());return d(t)?(Me(n[0],n[1],t),It(t),t):new C(n[0],n[1],N.UTC)};C.fromIso8601=function(e,t){if(typeof e!="string")throw new A(Oe);e=e.replace(",",".");let n=e.split("T"),i,s=1,r=1,c=0,u=0,p=0,b=0,g=n[0],w=n[1],x,R;if(!d(g))throw new A(Oe);let I;if(n=g.match(Zo),n!==null){if(I=g.split("-").length-1,I>0&&I!==2)throw new A(Oe);i=+n[1],s=+n[2],r=+n[3]}else if(n=g.match(Wo),n!==null)i=+n[1],s=+n[2];else if(n=g.match(Ho),n!==null)i=+n[1];else{let k;if(n=g.match(Vo),n!==null){if(i=+n[1],k=+n[2],R=ft(i),k<1||R&&k>366||!R&&k>365)throw new A(Oe)}else if(n=g.match(Yo),n!==null){i=+n[1];let q=+n[2],F=+n[3]||0;if(I=g.split("-").length-1,I>0&&(!d(n[3])&&I!==1||d(n[3])&&I!==2))throw new A(Oe);let j=new Date(Date.UTC(i,0,4));k=q*7+F-j.getUTCDay()-3}else throw new A(Oe);x=new Date(Date.UTC(i,0,1)),x.setUTCDate(k),s=x.getUTCMonth()+1,r=x.getUTCDate()}if(R=ft(i),s<1||s>12||r<1||(s!==2||!R)&&r>Rt[s-1]||R&&s===2&&r>Pt)throw new A(Oe);let T;if(d(w)){if(n=w.match(Go),n!==null){if(I=w.split(":").length-1,I>0&&I!==2&&I!==3)throw new A(Oe);c=+n[1],u=+n[2],p=+n[3],b=+(n[4]||0)*1e3,T=5}else if(n=w.match(Jo),n!==null){if(I=w.split(":").length-1,I>2)throw new A(Oe);c=+n[1],u=+n[2],p=+(n[3]||0)*60,T=4}else if(n=w.match(Xo),n!==null)c=+n[1],u=+(n[2]||0)*60,T=3;else throw new A(Oe);if(u>=60||p>=61||c>24||c===24&&(u>0||p>0||b>0))throw new A(Oe);let k=n[T],q=+n[T+1],F=+(n[T+2]||0);switch(k){case"+":c=c-q,u=u-F;break;case"-":c=c+q,u=u+F;break;case"Z":break;default:u=u+new Date(Date.UTC(i,s-1,r,c,u)).getTimezoneOffset();break}}let M=p===60;for(M&&p--;u>=60;)u-=60,c++;for(;c>=24;)c-=24,r++;for(x=R&&s===2?Pt:Rt[s-1];r>x;)r-=x,s++,s>12&&(s-=12,i++),x=R&&s===2?Pt:Rt[s-1];for(;u<0;)u+=60,c--;for(;c<0;)c+=24,r--;for(;r<1;)s--,s<1&&(s+=12,i--),x=R&&s===2?Pt:Rt[s-1],r+=x;let U=On(i,s,r,c,u,p,b);return d(t)?(Me(U[0],U[1],t),It(t)):t=new C(U[0],U[1],N.UTC),M&&C.addSeconds(t,1,t),t};C.now=function(e){return C.fromDate(new Date,e)};var Tt=new C(0,0,N.TAI);C.toGregorianDate=function(e,t){if(!d(e))throw new A("julianDate is required.");let n=!1,i=or(e,Tt);d(i)||(C.addSeconds(e,-1,Tt),i=or(Tt,Tt),n=!0);let s=i.dayNumber,r=i.secondsOfDay;r>=43200&&(s+=1);let c=s+68569|0,u=4*c/146097|0;c=c-((146097*u+3)/4|0)|0;let p=4e3*(c+1)/1461001|0;c=c-(1461*p/4|0)+31|0;let b=80*c/2447|0,g=c-(2447*b/80|0)|0;c=b/11|0;let w=b+2-12*c|0,x=100*(u-49)+p+c|0,R=r/K.SECONDS_PER_HOUR|0,I=r-R*K.SECONDS_PER_HOUR,T=I/K.SECONDS_PER_MINUTE|0;I=I-T*K.SECONDS_PER_MINUTE;let M=I|0,U=(I-M)/K.SECONDS_PER_MILLISECOND;return R+=12,R>23&&(R-=24),n&&(M+=1),d(t)?(t.year=x,t.month=w,t.day=g,t.hour=R,t.minute=T,t.second=M,t.millisecond=U,t.isLeapSecond=n,t):new At(x,w,g,R,T,M,U,n)};C.toDate=function(e){if(!d(e))throw new A("julianDate is required.");let t=C.toGregorianDate(e,ir),n=t.second;return t.isLeapSecond&&(n-=1),new Date(Date.UTC(t.year,t.month-1,t.day,t.hour,t.minute,n,t.millisecond))};C.toIso8601=function(e,t){if(!d(e))throw new A("julianDate is required.");let n=C.toGregorianDate(e,ir),i=n.year,s=n.month,r=n.day,c=n.hour,u=n.minute,p=n.second,b=n.millisecond;i===1e4&&s===1&&r===1&&c===0&&u===0&&p===0&&b===0&&(i=9999,s=12,r=31,c=24);let g;return!d(t)&&b!==0?(g=(b*.01).toString().replace(".",""),`${i.toString().padStart(4,"0")}-${s.toString().padStart(2,"0")}-${r.toString().padStart(2,"0")}T${c.toString().padStart(2,"0")}:${u.toString().padStart(2,"0")}:${p.toString().padStart(2,"0")}.${g}Z`):!d(t)||t===0?`${i.toString().padStart(4,"0")}-${s.toString().padStart(2,"0")}-${r.toString().padStart(2,"0")}T${c.toString().padStart(2,"0")}:${u.toString().padStart(2,"0")}:${p.toString().padStart(2,"0")}Z`:(g=(b*.01).toFixed(t).replace(".","").slice(0,t),`${i.toString().padStart(4,"0")}-${s.toString().padStart(2,"0")}-${r.toString().padStart(2,"0")}T${c.toString().padStart(2,"0")}:${u.toString().padStart(2,"0")}:${p.toString().padStart(2,"0")}.${g}Z`)};C.clone=function(e,t){if(d(e))return d(t)?(t.dayNumber=e.dayNumber,t.secondsOfDay=e.secondsOfDay,t):new C(e.dayNumber,e.secondsOfDay,N.TAI)};C.compare=function(e,t){if(!d(e))throw new A("left is required.");if(!d(t))throw new A("right is required.");let n=e.dayNumber-t.dayNumber;return n!==0?n:e.secondsOfDay-t.secondsOfDay};C.equals=function(e,t){return e===t||d(e)&&d(t)&&e.dayNumber===t.dayNumber&&e.secondsOfDay===t.secondsOfDay};C.equalsEpsilon=function(e,t,n){return n=O(n,0),e===t||d(e)&&d(t)&&Math.abs(C.secondsDifference(e,t))<=n};C.totalDays=function(e){if(!d(e))throw new A("julianDate is required.");return e.dayNumber+e.secondsOfDay/K.SECONDS_PER_DAY};C.secondsDifference=function(e,t){if(!d(e))throw new A("left is required.");if(!d(t))throw new A("right is required.");return(e.dayNumber-t.dayNumber)*K.SECONDS_PER_DAY+(e.secondsOfDay-t.secondsOfDay)};C.daysDifference=function(e,t){if(!d(e))throw new A("left is required.");if(!d(t))throw new A("right is required.");let n=e.dayNumber-t.dayNumber,i=(e.secondsOfDay-t.secondsOfDay)/K.SECONDS_PER_DAY;return n+i};C.computeTaiMinusUtc=function(e){Ke.julianDate=e;let t=C.leapSeconds,n=Qe(t,Ke,Sn);return n<0&&(n=~n,--n,n<0&&(n=0)),t[n].offset};C.addSeconds=function(e,t,n){if(!d(e))throw new A("julianDate is required.");if(!d(t))throw new A("seconds is required.");if(!d(n))throw new A("result is required.");return Me(e.dayNumber,e.secondsOfDay+t,n)};C.addMinutes=function(e,t,n){if(!d(e))throw new A("julianDate is required.");if(!d(t))throw new A("minutes is required.");if(!d(n))throw new A("result is required.");let i=e.secondsOfDay+t*K.SECONDS_PER_MINUTE;return Me(e.dayNumber,i,n)};C.addHours=function(e,t,n){if(!d(e))throw new A("julianDate is required.");if(!d(t))throw new A("hours is required.");if(!d(n))throw new A("result is required.");let i=e.secondsOfDay+t*K.SECONDS_PER_HOUR;return Me(e.dayNumber,i,n)};C.addDays=function(e,t,n){if(!d(e))throw new A("julianDate is required.");if(!d(t))throw new A("days is required.");if(!d(n))throw new A("result is required.");let i=e.dayNumber+t;return Me(i,e.secondsOfDay,n)};C.lessThan=function(e,t){return C.compare(e,t)<0};C.lessThanOrEquals=function(e,t){return C.compare(e,t)<=0};C.greaterThan=function(e,t){return C.compare(e,t)>0};C.greaterThanOrEquals=function(e,t){return C.compare(e,t)>=0};C.prototype.clone=function(e){return C.clone(this,e)};C.prototype.equals=function(e){return C.equals(this,e)};C.prototype.equalsEpsilon=function(e,t){return C.equalsEpsilon(this,e,t)};C.prototype.toString=function(){return C.toIso8601(this)};C.leapSeconds=[new Z(new C(2441317,43210,N.TAI),10),new Z(new C(2441499,43211,N.TAI),11),new Z(new C(2441683,43212,N.TAI),12),new Z(new C(2442048,43213,N.TAI),13),new Z(new C(2442413,43214,N.TAI),14),new Z(new C(2442778,43215,N.TAI),15),new Z(new C(2443144,43216,N.TAI),16),new Z(new C(2443509,43217,N.TAI),17),new Z(new C(2443874,43218,N.TAI),18),new Z(new C(2444239,43219,N.TAI),19),new Z(new C(2444786,43220,N.TAI),20),new Z(new C(2445151,43221,N.TAI),21),new Z(new C(2445516,43222,N.TAI),22),new Z(new C(2446247,43223,N.TAI),23),new Z(new C(2447161,43224,N.TAI),24),new Z(new C(2447892,43225,N.TAI),25),new Z(new C(2448257,43226,N.TAI),26),new Z(new C(2448804,43227,N.TAI),27),new Z(new C(2449169,43228,N.TAI),28),new Z(new C(2449534,43229,N.TAI),29),new Z(new C(2450083,43230,N.TAI),30),new Z(new C(2450630,43231,N.TAI),31),new Z(new C(2451179,43232,N.TAI),32),new Z(new C(2453736,43233,N.TAI),33),new Z(new C(2454832,43234,N.TAI),34),new Z(new C(2456109,43235,N.TAI),35),new Z(new C(2457204,43236,N.TAI),36),new Z(new C(2457754,43237,N.TAI),37)];var ue=C;var zr=Ge($e(),1);function Ko(e){return(e.length===0||e[e.length-1]!=="/")&&(e=`${e}/`),e}var dr=Ko;function pr(e,t){if(e===null||typeof e!="object")return e;t=O(t,!1);let n=new e.constructor;for(let i in e)if(e.hasOwnProperty(i)){let s=e[i];t&&(s=pr(s,t)),n[i]=s}return n}var nt=pr;function ei(){let e,t,n=new Promise(function(i,s){e=i,t=s});return{resolve:e,reject:t,promise:n}}var He=ei;var mr=Ge($e(),1);function En(e,t){let n;return typeof document<"u"&&(n=document),En._implementation(e,t,n)}En._implementation=function(e,t,n){if(!d(e))throw new A("relative uri is required.");if(!d(t)){if(typeof n>"u")return e;t=O(n.baseURI,n.location.href)}let i=new mr.default(e);return i.scheme()!==""?i.toString():i.absoluteTo(t).toString()};var lt=En;var hr=Ge($e(),1);function ti(e,t){if(!d(e))throw new A("uri is required.");let n="",i=e.lastIndexOf("/");return i!==-1&&(n=e.substring(0,i+1)),t&&(e=new hr.default(e),e.query().length!==0&&(n+=`?${e.query()}`),e.fragment().length!==0&&(n+=`#${e.fragment()}`)),n}var yr=ti;var gr=Ge($e(),1);function ni(e){if(!d(e))throw new A("uri is required.");let t=new gr.default(e);t.normalize();let n=t.path(),i=n.lastIndexOf("/");return i!==-1&&(n=n.substr(i+1)),i=n.lastIndexOf("."),i===-1?n="":n=n.substr(i+1),n}var wr=ni;var br={};function ri(e,t,n){d(t)||(t=e.width),d(n)||(n=e.height);let i=br[t];d(i)||(i={},br[t]=i);let s=i[n];if(!d(s)){let r=document.createElement("canvas");r.width=t,r.height=n,s=r.getContext("2d",{willReadFrequently:!0}),s.globalCompositeOperation="copy",i[n]=s}return s.drawImage(e,0,0,t,n),s.getImageData(0,0,t,n).data}var Cn=ri;var oi=/^blob:/i;function ii(e){return h.typeOf.string("uri",e),oi.test(e)}var zt=ii;var Ee;function si(e){d(Ee)||(Ee=document.createElement("a")),Ee.href=window.location.href;let t=Ee.host,n=Ee.protocol;return Ee.href=e,Ee.href=Ee.href,n!==Ee.protocol||t!==Ee.host}var _r=si;var ai=/^data:/i;function ci(e){return h.typeOf.string("uri",e),ai.test(e)}var Mt=ci;function ui(e){let t=document.createElement("script");return t.async=!0,t.src=e,new Promise((n,i)=>{window.crossOriginIsolated&&t.setAttribute("crossorigin","anonymous");let s=document.getElementsByTagName("head")[0];t.onload=function(){t.onload=void 0,s.removeChild(t),n()},t.onerror=function(r){i(r)},s.appendChild(t)})}var xr=ui;function fi(e){if(!d(e))throw new A("obj is required.");let t="";for(let n in e)if(e.hasOwnProperty(n)){let i=e[n],s=`${encodeURIComponent(n)}=`;if(Array.isArray(i))for(let r=0,c=i.length;r<c;++r)t+=`${s+encodeURIComponent(i[r])}&`;else t+=`${s+encodeURIComponent(i)}&`}return t=t.slice(0,-1),t}var Sr=fi;function li(e){if(!d(e))throw new A("queryString is required.");let t={};if(e==="")return t;let n=e.replace(/\+/g,"%20").split(/[&;]/);for(let i=0,s=n.length;i<s;++i){let r=n[i].split("="),c=decodeURIComponent(r[0]),u=r[1];d(u)?u=decodeURIComponent(u):u="";let p=t[c];typeof p=="string"?t[c]=[p,u]:Array.isArray(p)?p.push(u):t[c]=u}return t}var Or=li;var di={UNISSUED:0,ISSUED:1,ACTIVE:2,RECEIVED:3,CANCELLED:4,FAILED:5},te=Object.freeze(di);var pi={TERRAIN:0,IMAGERY:1,TILES3D:2,OTHER:3},vr=Object.freeze(pi);function kt(e){e=O(e,O.EMPTY_OBJECT);let t=O(e.throttleByServer,!1),n=O(e.throttle,!1);this.url=e.url,this.requestFunction=e.requestFunction,this.cancelFunction=e.cancelFunction,this.priorityFunction=e.priorityFunction,this.priority=O(e.priority,0),this.throttle=n,this.throttleByServer=t,this.type=O(e.type,vr.OTHER),this.serverKey=e.serverKey,this.state=te.UNISSUED,this.deferred=void 0,this.cancelled=!1}kt.prototype.cancel=function(){this.cancelled=!0};kt.prototype.clone=function(e){return d(e)?(e.url=this.url,e.requestFunction=this.requestFunction,e.cancelFunction=this.cancelFunction,e.priorityFunction=this.priorityFunction,e.priority=this.priority,e.throttle=this.throttle,e.throttleByServer=this.throttleByServer,e.type=this.type,e.serverKey=this.serverKey,e.state=te.UNISSUED,e.deferred=void 0,e.cancelled=!1,e):new kt(this)};var Er=kt;function mi(e){let t={};if(!e)return t;let n=e.split(`\r
`);for(let i=0;i<n.length;++i){let s=n[i],r=s.indexOf(": ");if(r>0){let c=s.substring(0,r),u=s.substring(r+2);t[c]=u}}return t}var Cr=mi;function Ar(e,t,n){this.statusCode=e,this.response=t,this.responseHeaders=n,typeof this.responseHeaders=="string"&&(this.responseHeaders=Cr(this.responseHeaders))}Ar.prototype.toString=function(){let e="Request has failed.";return d(this.statusCode)&&(e+=` Status Code: ${this.statusCode}`),e};var dt=Ar;var Ft=Ge($e(),1);function pt(){this._listeners=[],this._scopes=[],this._toRemove=[],this._insideRaiseEvent=!1}Object.defineProperties(pt.prototype,{numberOfListeners:{get:function(){return this._listeners.length-this._toRemove.length}}});pt.prototype.addEventListener=function(e,t){h.typeOf.func("listener",e),this._listeners.push(e),this._scopes.push(t);let n=this;return function(){n.removeEventListener(e,t)}};pt.prototype.removeEventListener=function(e,t){h.typeOf.func("listener",e);let n=this._listeners,i=this._scopes,s=-1;for(let r=0;r<n.length;r++)if(n[r]===e&&i[r]===t){s=r;break}return s!==-1?(this._insideRaiseEvent?(this._toRemove.push(s),n[s]=void 0,i[s]=void 0):(n.splice(s,1),i.splice(s,1)),!0):!1};function hi(e,t){return t-e}pt.prototype.raiseEvent=function(){this._insideRaiseEvent=!0;let e,t=this._listeners,n=this._scopes,i=t.length;for(e=0;e<i;e++){let r=t[e];d(r)&&t[e].apply(n[e],arguments)}let s=this._toRemove;if(i=s.length,i>0){for(s.sort(hi),e=0;e<i;e++){let r=s[e];t.splice(r,1),n.splice(r,1)}s.length=0}this._insideRaiseEvent=!1};var Rr=pt;function We(e){h.typeOf.object("options",e),h.defined("options.comparator",e.comparator),this._comparator=e.comparator,this._array=[],this._length=0,this._maximumLength=void 0}Object.defineProperties(We.prototype,{length:{get:function(){return this._length}},internalArray:{get:function(){return this._array}},maximumLength:{get:function(){return this._maximumLength},set:function(e){h.typeOf.number.greaterThanOrEquals("maximumLength",e,0);let t=this._length;if(e<t){let n=this._array;for(let i=e;i<t;++i)n[i]=void 0;this._length=e,n.length=e}this._maximumLength=e}},comparator:{get:function(){return this._comparator}}});function An(e,t,n){let i=e[t];e[t]=e[n],e[n]=i}We.prototype.reserve=function(e){e=O(e,this._length),this._array.length=e};We.prototype.heapify=function(e){e=O(e,0);let t=this._length,n=this._comparator,i=this._array,s=-1,r=!0;for(;r;){let c=2*(e+1),u=c-1;u<t&&n(i[u],i[e])<0?s=u:s=e,c<t&&n(i[c],i[s])<0&&(s=c),s!==e?(An(i,s,e),e=s):r=!1}};We.prototype.resort=function(){let e=this._length;for(let t=Math.ceil(e/2);t>=0;--t)this.heapify(t)};We.prototype.insert=function(e){h.defined("element",e);let t=this._array,n=this._comparator,i=this._maximumLength,s=this._length++;for(s<t.length?t[s]=e:t.push(e);s!==0;){let c=Math.floor((s-1)/2);if(n(t[s],t[c])<0)An(t,s,c),s=c;else break}let r;return d(i)&&this._length>i&&(r=t[i],this._length=i),r};We.prototype.pop=function(e){if(e=O(e,0),this._length===0)return;h.typeOf.number.lessThan("index",e,this._length);let t=this._array,n=t[e];return An(t,e,--this._length),this.heapify(e),t[this._length]=void 0,n};var Pr=We;function yi(e,t){return e.priority-t.priority}var Y={numberOfAttemptedRequests:0,numberOfActiveRequests:0,numberOfCancelledRequests:0,numberOfCancelledActiveRequests:0,numberOfFailedRequests:0,numberOfActiveRequestsEver:0,lastNumberOfActiveRequests:0},rt=20,le=new Pr({comparator:yi});le.maximumLength=rt;le.reserve(rt);var Ce=[],Pe={},gi=typeof document<"u"?new Ft.default(document.location.href):new Ft.default,jt=new Rr;function ee(){}ee.maximumRequests=50;ee.maximumRequestsPerServer=18;ee.requestsByServer={};ee.throttleRequests=!0;ee.debugShowStatistics=!1;ee.requestCompletedEvent=jt;Object.defineProperties(ee,{statistics:{get:function(){return Y}},priorityHeapLength:{get:function(){return rt},set:function(e){if(e<rt)for(;le.length>e;){let t=le.pop();Ve(t)}rt=e,le.maximumLength=e,le.reserve(e)}}});function Tr(e){d(e.priorityFunction)&&(e.priority=e.priorityFunction())}ee.serverHasOpenSlots=function(e,t){t=O(t,1);let n=O(ee.requestsByServer[e],ee.maximumRequestsPerServer);return Pe[e]+t<=n};ee.heapHasOpenSlots=function(e){return le.length+e<=rt};function Ir(e){return e.state===te.UNISSUED&&(e.state=te.ISSUED,e.deferred=He()),e.deferred.promise}function wi(e){return function(t){if(e.state===te.CANCELLED)return;let n=e.deferred;--Y.numberOfActiveRequests,--Pe[e.serverKey],jt.raiseEvent(),e.state=te.RECEIVED,e.deferred=void 0,n.resolve(t)}}function bi(e){return function(t){e.state!==te.CANCELLED&&(++Y.numberOfFailedRequests,--Y.numberOfActiveRequests,--Pe[e.serverKey],jt.raiseEvent(t),e.state=te.FAILED,e.deferred.reject(t))}}function Ur(e){let t=Ir(e);return e.state=te.ACTIVE,Ce.push(e),++Y.numberOfActiveRequests,++Y.numberOfActiveRequestsEver,++Pe[e.serverKey],e.requestFunction().then(wi(e)).catch(bi(e)),t}function Ve(e){let t=e.state===te.ACTIVE;if(e.state=te.CANCELLED,++Y.numberOfCancelledRequests,d(e.deferred)){let n=e.deferred;e.deferred=void 0,n.reject()}t&&(--Y.numberOfActiveRequests,--Pe[e.serverKey],++Y.numberOfCancelledActiveRequests),d(e.cancelFunction)&&e.cancelFunction()}ee.update=function(){let e,t,n=0,i=Ce.length;for(e=0;e<i;++e){if(t=Ce[e],t.cancelled&&Ve(t),t.state!==te.ACTIVE){++n;continue}n>0&&(Ce[e-n]=t)}Ce.length-=n;let s=le.internalArray,r=le.length;for(e=0;e<r;++e)Tr(s[e]);le.resort();let c=Math.max(ee.maximumRequests-Ce.length,0),u=0;for(;u<c&&le.length>0;){if(t=le.pop(),t.cancelled){Ve(t);continue}if(t.throttleByServer&&!ee.serverHasOpenSlots(t.serverKey)){Ve(t);continue}Ur(t),++u}_i()};ee.getServerKey=function(e){h.typeOf.string("url",e);let t=new Ft.default(e);t.scheme()===""&&(t=t.absoluteTo(gi),t.normalize());let n=t.authority();/:/.test(n)||(n=`${n}:${t.scheme()==="https"?"443":"80"}`);let i=Pe[n];return d(i)||(Pe[n]=0),n};ee.request=function(e){if(h.typeOf.object("request",e),h.typeOf.string("request.url",e.url),h.typeOf.func("request.requestFunction",e.requestFunction),Mt(e.url)||zt(e.url))return jt.raiseEvent(),e.state=te.RECEIVED,e.requestFunction();if(++Y.numberOfAttemptedRequests,d(e.serverKey)||(e.serverKey=ee.getServerKey(e.url)),ee.throttleRequests&&e.throttleByServer&&!ee.serverHasOpenSlots(e.serverKey))return;if(!ee.throttleRequests||!e.throttle)return Ur(e);if(Ce.length>=ee.maximumRequests)return;Tr(e);let t=le.insert(e);if(d(t)){if(t===e)return;Ve(t)}return Ir(e)};function _i(){ee.debugShowStatistics&&(Y.numberOfActiveRequests===0&&Y.lastNumberOfActiveRequests>0&&(Y.numberOfAttemptedRequests>0&&(console.log(`Number of attempted requests: ${Y.numberOfAttemptedRequests}`),Y.numberOfAttemptedRequests=0),Y.numberOfCancelledRequests>0&&(console.log(`Number of cancelled requests: ${Y.numberOfCancelledRequests}`),Y.numberOfCancelledRequests=0),Y.numberOfCancelledActiveRequests>0&&(console.log(`Number of cancelled active requests: ${Y.numberOfCancelledActiveRequests}`),Y.numberOfCancelledActiveRequests=0),Y.numberOfFailedRequests>0&&(console.log(`Number of failed requests: ${Y.numberOfFailedRequests}`),Y.numberOfFailedRequests=0)),Y.lastNumberOfActiveRequests=Y.numberOfActiveRequests)}ee.clearForSpecs=function(){for(;le.length>0;){let t=le.pop();Ve(t)}let e=Ce.length;for(let t=0;t<e;++t)Ve(Ce[t]);Ce.length=0,Pe={},Y.numberOfAttemptedRequests=0,Y.numberOfActiveRequests=0,Y.numberOfCancelledRequests=0,Y.numberOfCancelledActiveRequests=0,Y.numberOfFailedRequests=0,Y.numberOfActiveRequestsEver=0,Y.lastNumberOfActiveRequests=0};ee.numberOfActiveRequestsByServer=function(e){return Pe[e]};ee.requestHeap=le;var Nt=ee;var Dr=Ge($e(),1);var mt={},ot={};mt.add=function(e,t){if(!d(e))throw new A("host is required.");if(!d(t)||t<=0)throw new A("port is required to be greater than 0.");let n=`${e.toLowerCase()}:${t}`;d(ot[n])||(ot[n]=!0)};mt.remove=function(e,t){if(!d(e))throw new A("host is required.");if(!d(t)||t<=0)throw new A("port is required to be greater than 0.");let n=`${e.toLowerCase()}:${t}`;d(ot[n])&&delete ot[n]};function xi(e){let t=new Dr.default(e);t.normalize();let n=t.authority();if(n.length!==0){if(t.authority(n),n.indexOf("@")!==-1&&(n=n.split("@")[1]),n.indexOf(":")===-1){let i=t.scheme();if(i.length===0&&(i=window.location.protocol,i=i.substring(0,i.length-1)),i==="http")n+=":80";else if(i==="https")n+=":443";else return}return n}}mt.contains=function(e){if(!d(e))throw new A("url is required.");let t=xi(e);return!!(d(t)&&d(ot[t]))};mt.clear=function(){ot={}};var Rn=mt;var Mr=function(){try{let e=new XMLHttpRequest;return e.open("GET","#",!0),e.responseType="blob",e.responseType==="blob"}catch{return!1}}();function E(e){e=O(e,O.EMPTY_OBJECT),typeof e=="string"&&(e={url:e}),h.typeOf.string("options.url",e.url),this._url=void 0,this._templateValues=Ae(e.templateValues,{}),this._queryParameters=Ae(e.queryParameters,{}),this.headers=Ae(e.headers,{}),this.request=O(e.request,new Er),this.proxy=e.proxy,this.retryCallback=e.retryCallback,this.retryAttempts=O(e.retryAttempts,0),this._retryCount=0,O(e.parseUrl,!0)?this.parseUrl(e.url,!0,!0):this._url=e.url,this._credits=e.credits}function Ae(e,t){return d(e)?nt(e):t}E.createIfNeeded=function(e){return e instanceof E?e.getDerivedResource({request:e.request}):typeof e!="string"?e:new E({url:e})};var it;E.supportsImageBitmapOptions=function(){return d(it)?it:typeof createImageBitmap!="function"?(it=Promise.resolve(!1),it):(it=E.fetchBlob({url:"data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAIAAACQd1PeAAAABGdBTUEAAE4g3rEiDgAAACBjSFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAADElEQVQI12Ng6GAAAAEUAIngE3ZiAAAAAElFTkSuQmCC"}).then(function(t){let n={imageOrientation:"flipY",premultiplyAlpha:"none",colorSpaceConversion:"none"};return Promise.all([createImageBitmap(t,n),createImageBitmap(t)])}).then(function(t){let n=Cn(t[0]),i=Cn(t[1]);return n[1]!==i[1]}).catch(function(){return!1}),it)};Object.defineProperties(E,{isBlobSupported:{get:function(){return Mr}}});Object.defineProperties(E.prototype,{queryParameters:{get:function(){return this._queryParameters}},templateValues:{get:function(){return this._templateValues}},url:{get:function(){return this.getUrlComponent(!0,!0)},set:function(e){this.parseUrl(e,!1,!1)}},extension:{get:function(){return wr(this._url)}},isDataUri:{get:function(){return Mt(this._url)}},isBlobUri:{get:function(){return zt(this._url)}},isCrossOriginUrl:{get:function(){return _r(this._url)}},hasHeaders:{get:function(){return Object.keys(this.headers).length>0}},credits:{get:function(){return this._credits}}});E.prototype.toString=function(){return this.getUrlComponent(!0,!0)};E.prototype.parseUrl=function(e,t,n,i){let s=new zr.default(e),r=Si(s.query());this._queryParameters=t?Lt(r,this.queryParameters,n):r,s.search(""),s.fragment(""),d(i)&&s.scheme()===""&&(s=s.absoluteTo(lt(i))),this._url=s.toString()};function Si(e){return e.length===0?{}:e.indexOf("=")===-1?{[e]:void 0}:Or(e)}function Lt(e,t,n){if(!n)return ze(e,t);let i=nt(e,!0);for(let s in t)if(t.hasOwnProperty(s)){let r=i[s],c=t[s];d(r)?(Array.isArray(r)||(r=i[s]=[r]),i[s]=r.concat(c)):i[s]=Array.isArray(c)?c.slice():c}return i}E.prototype.getUrlComponent=function(e,t){if(this.isDataUri)return this._url;let n=this._url;e&&(n=`${n}${Oi(this.queryParameters)}`),n=n.replace(/%7B/g,"{").replace(/%7D/g,"}");let i=this._templateValues;return Object.keys(i).length>0&&(n=n.replace(/{(.*?)}/g,function(s,r){let c=i[r];return d(c)?encodeURIComponent(c):s})),t&&d(this.proxy)&&(n=this.proxy.getURL(n)),n};function Oi(e){let t=Object.keys(e);return t.length===0?"":t.length===1&&!d(e[t[0]])?`?${t[0]}`:`?${Sr(e)}`}E.prototype.setQueryParameters=function(e,t){t?this._queryParameters=Lt(this._queryParameters,e,!1):this._queryParameters=Lt(e,this._queryParameters,!1)};E.prototype.appendQueryParameters=function(e){this._queryParameters=Lt(e,this._queryParameters,!0)};E.prototype.setTemplateValues=function(e,t){t?this._templateValues=ze(this._templateValues,e):this._templateValues=ze(e,this._templateValues)};E.prototype.getDerivedResource=function(e){let t=this.clone();if(t._retryCount=0,d(e.url)){let n=O(e.preserveQueryParameters,!1);t.parseUrl(e.url,!0,n,this._url)}return d(e.queryParameters)&&(t._queryParameters=ze(e.queryParameters,t.queryParameters)),d(e.templateValues)&&(t._templateValues=ze(e.templateValues,t.templateValues)),d(e.headers)&&(t.headers=ze(e.headers,t.headers)),d(e.proxy)&&(t.proxy=e.proxy),d(e.request)&&(t.request=e.request),d(e.retryCallback)&&(t.retryCallback=e.retryCallback),d(e.retryAttempts)&&(t.retryAttempts=e.retryAttempts),t};E.prototype.retryOnError=function(e){let t=this.retryCallback;if(typeof t!="function"||this._retryCount>=this.retryAttempts)return Promise.resolve(!1);let n=this;return Promise.resolve(t(this,e)).then(function(i){return++n._retryCount,i})};E.prototype.clone=function(e){return d(e)?(e._url=this._url,e._queryParameters=nt(this._queryParameters),e._templateValues=nt(this._templateValues),e.headers=nt(this.headers),e.proxy=this.proxy,e.retryCallback=this.retryCallback,e.retryAttempts=this.retryAttempts,e._retryCount=0,e.request=this.request.clone(),e):new E({url:this._url,queryParameters:this.queryParameters,templateValues:this.templateValues,headers:this.headers,proxy:this.proxy,retryCallback:this.retryCallback,retryAttempts:this.retryAttempts,request:this.request.clone(),parseUrl:!1,credits:d(this.credits)?this.credits.slice():void 0})};E.prototype.getBaseUri=function(e){return yr(this.getUrlComponent(e),e)};E.prototype.appendForwardSlash=function(){this._url=dr(this._url)};E.prototype.fetchArrayBuffer=function(){return this.fetch({responseType:"arraybuffer"})};E.fetchArrayBuffer=function(e){return new E(e).fetchArrayBuffer()};E.prototype.fetchBlob=function(){return this.fetch({responseType:"blob"})};E.fetchBlob=function(e){return new E(e).fetchBlob()};E.prototype.fetchImage=function(e){e=O(e,O.EMPTY_OBJECT);let t=O(e.preferImageBitmap,!1),n=O(e.preferBlob,!1),i=O(e.flipY,!1),s=O(e.skipColorSpaceConversion,!1);if(Tn(this.request),!Mr||this.isDataUri||this.isBlobUri||!this.hasHeaders&&!n)return Pn({resource:this,flipY:i,skipColorSpaceConversion:s,preferImageBitmap:t});let r=this.fetchBlob();if(!d(r))return;let c,u,p,b;return E.supportsImageBitmapOptions().then(function(g){return c=g,u=c&&t,r}).then(function(g){if(!d(g))return;if(b=g,u)return E.createImageBitmapFromBlob(g,{flipY:i,premultiplyAlpha:!1,skipColorSpaceConversion:s});let w=window.URL.createObjectURL(g);return p=new E({url:w}),Pn({resource:p,flipY:i,skipColorSpaceConversion:s,preferImageBitmap:!1})}).then(function(g){if(d(g))return g.blob=b,u||window.URL.revokeObjectURL(p.url),g}).catch(function(g){return d(p)&&window.URL.revokeObjectURL(p.url),g.blob=b,Promise.reject(g)})};function Pn(e){let t=e.resource,n=e.flipY,i=e.skipColorSpaceConversion,s=e.preferImageBitmap,r=t.request;r.url=t.url,r.requestFunction=function(){let u=!1;!t.isDataUri&&!t.isBlobUri&&(u=t.isCrossOriginUrl);let p=He();return E._Implementations.createImage(r,u,p,n,i,s),p.promise};let c=Nt.request(r);if(d(c))return c.catch(function(u){return r.state!==te.FAILED?Promise.reject(u):t.retryOnError(u).then(function(p){return p?(r.state=te.UNISSUED,r.deferred=void 0,Pn({resource:t,flipY:n,skipColorSpaceConversion:i,preferImageBitmap:s})):Promise.reject(u)})})}E.fetchImage=function(e){return new E(e).fetchImage({flipY:e.flipY,skipColorSpaceConversion:e.skipColorSpaceConversion,preferBlob:e.preferBlob,preferImageBitmap:e.preferImageBitmap})};E.prototype.fetchText=function(){return this.fetch({responseType:"text"})};E.fetchText=function(e){return new E(e).fetchText()};E.prototype.fetchJson=function(){let e=this.fetch({responseType:"text",headers:{Accept:"application/json,*/*;q=0.01"}});if(d(e))return e.then(function(t){if(d(t))return JSON.parse(t)})};E.fetchJson=function(e){return new E(e).fetchJson()};E.prototype.fetchXML=function(){return this.fetch({responseType:"document",overrideMimeType:"text/xml"})};E.fetchXML=function(e){return new E(e).fetchXML()};E.prototype.fetchJsonp=function(e){e=O(e,"callback"),Tn(this.request);let t;do t=`loadJsonp${X.nextRandomNumber().toString().substring(2,8)}`;while(d(window[t]));return kr(this,e,t)};function kr(e,t,n){let i={};i[t]=n,e.setQueryParameters(i);let s=e.request,r=e.url;s.url=r,s.requestFunction=function(){let u=He();return window[n]=function(p){u.resolve(p);try{delete window[n]}catch{window[n]=void 0}},E._Implementations.loadAndExecuteScript(r,n,u),u.promise};let c=Nt.request(s);if(d(c))return c.catch(function(u){return s.state!==te.FAILED?Promise.reject(u):e.retryOnError(u).then(function(p){return p?(s.state=te.UNISSUED,s.deferred=void 0,kr(e,t,n)):Promise.reject(u)})})}E.fetchJsonp=function(e){return new E(e).fetchJsonp(e.callbackParameterName)};E.prototype._makeRequest=function(e){let t=this;Tn(t.request);let n=t.request,i=t.url;n.url=i,n.requestFunction=function(){let r=e.responseType,c=ze(e.headers,t.headers),u=e.overrideMimeType,p=e.method,b=e.data,g=He(),w=E._Implementations.loadWithXhr(i,r,p,b,c,g,u);return d(w)&&d(w.abort)&&(n.cancelFunction=function(){w.abort()}),g.promise};let s=Nt.request(n);if(d(s))return s.then(function(r){return n.cancelFunction=void 0,r}).catch(function(r){return n.cancelFunction=void 0,n.state!==te.FAILED?Promise.reject(r):t.retryOnError(r).then(function(c){return c?(n.state=te.UNISSUED,n.deferred=void 0,t.fetch(e)):Promise.reject(r)})})};function Tn(e){if(e.state===te.ISSUED||e.state===te.ACTIVE)throw new Re("The Resource is already being fetched.");e.state=te.UNISSUED,e.deferred=void 0}var vi=/^data:(.*?)(;base64)?,(.*)$/;function Bt(e,t){let n=decodeURIComponent(t);return e?atob(n):n}function qr(e,t){let n=Bt(e,t),i=new ArrayBuffer(n.length),s=new Uint8Array(i);for(let r=0;r<n.length;r++)s[r]=n.charCodeAt(r);return i}function Ei(e,t){t=O(t,"");let n=e[1],i=!!e[2],s=e[3],r,c;switch(t){case"":case"text":return Bt(i,s);case"arraybuffer":return qr(i,s);case"blob":return r=qr(i,s),new Blob([r],{type:n});case"document":return c=new DOMParser,c.parseFromString(Bt(i,s),n);case"json":return JSON.parse(Bt(i,s));default:throw new A(`Unhandled responseType: ${t}`)}}E.prototype.fetch=function(e){return e=Ae(e,{}),e.method="GET",this._makeRequest(e)};E.fetch=function(e){return new E(e).fetch({responseType:e.responseType,overrideMimeType:e.overrideMimeType})};E.prototype.delete=function(e){return e=Ae(e,{}),e.method="DELETE",this._makeRequest(e)};E.delete=function(e){return new E(e).delete({responseType:e.responseType,overrideMimeType:e.overrideMimeType,data:e.data})};E.prototype.head=function(e){return e=Ae(e,{}),e.method="HEAD",this._makeRequest(e)};E.head=function(e){return new E(e).head({responseType:e.responseType,overrideMimeType:e.overrideMimeType})};E.prototype.options=function(e){return e=Ae(e,{}),e.method="OPTIONS",this._makeRequest(e)};E.options=function(e){return new E(e).options({responseType:e.responseType,overrideMimeType:e.overrideMimeType})};E.prototype.post=function(e,t){return h.defined("data",e),t=Ae(t,{}),t.method="POST",t.data=e,this._makeRequest(t)};E.post=function(e){return new E(e).post(e.data,{responseType:e.responseType,overrideMimeType:e.overrideMimeType})};E.prototype.put=function(e,t){return h.defined("data",e),t=Ae(t,{}),t.method="PUT",t.data=e,this._makeRequest(t)};E.put=function(e){return new E(e).put(e.data,{responseType:e.responseType,overrideMimeType:e.overrideMimeType})};E.prototype.patch=function(e,t){return h.defined("data",e),t=Ae(t,{}),t.method="PATCH",t.data=e,this._makeRequest(t)};E.patch=function(e){return new E(e).patch(e.data,{responseType:e.responseType,overrideMimeType:e.overrideMimeType})};E._Implementations={};E._Implementations.loadImageElement=function(e,t,n){let i=new Image;i.onload=function(){i.naturalWidth===0&&i.naturalHeight===0&&i.width===0&&i.height===0&&(i.width=300,i.height=150),n.resolve(i)},i.onerror=function(s){n.reject(s)},t&&(Rn.contains(e)?i.crossOrigin="use-credentials":i.crossOrigin=""),i.src=e};E._Implementations.createImage=function(e,t,n,i,s,r){let c=e.url;E.supportsImageBitmapOptions().then(function(u){if(!(u&&r)){E._Implementations.loadImageElement(c,t,n);return}let p="blob",b="GET",g=He(),w=E._Implementations.loadWithXhr(c,p,b,void 0,void 0,g,void 0,void 0,void 0);return d(w)&&d(w.abort)&&(e.cancelFunction=function(){w.abort()}),g.promise.then(function(x){if(!d(x)){n.reject(new Re(`Successfully retrieved ${c} but it contained no content.`));return}return E.createImageBitmapFromBlob(x,{flipY:i,premultiplyAlpha:!1,skipColorSpaceConversion:s})}).then(function(x){n.resolve(x)})}).catch(function(u){n.reject(u)})};E.createImageBitmapFromBlob=function(e,t){return h.defined("options",t),h.typeOf.bool("options.flipY",t.flipY),h.typeOf.bool("options.premultiplyAlpha",t.premultiplyAlpha),h.typeOf.bool("options.skipColorSpaceConversion",t.skipColorSpaceConversion),createImageBitmap(e,{imageOrientation:t.flipY?"flipY":"none",premultiplyAlpha:t.premultiplyAlpha?"premultiply":"none",colorSpaceConversion:t.skipColorSpaceConversion?"none":"default"})};function Ci(e,t,n,i,s,r,c){fetch(e,{method:n,headers:s}).then(async u=>{if(!u.ok){let p={};u.headers.forEach((b,g)=>{p[g]=b}),r.reject(new dt(u.status,u,p));return}switch(t){case"text":r.resolve(u.text());break;case"json":r.resolve(u.json());break;default:r.resolve(new Uint8Array(await u.arrayBuffer()).buffer);break}}).catch(()=>{r.reject(new dt)})}var Ai=typeof XMLHttpRequest>"u";E._Implementations.loadWithXhr=function(e,t,n,i,s,r,c){let u=vi.exec(e);if(u!==null){r.resolve(Ei(u,t));return}if(Ai){Ci(e,t,n,i,s,r,c);return}let p=new XMLHttpRequest;if(Rn.contains(e)&&(p.withCredentials=!0),p.open(n,e,!0),d(c)&&d(p.overrideMimeType)&&p.overrideMimeType(c),d(s))for(let g in s)s.hasOwnProperty(g)&&p.setRequestHeader(g,s[g]);d(t)&&(p.responseType=t);let b=!1;return typeof e=="string"&&(b=e.indexOf("file://")===0||typeof window<"u"&&window.location.origin==="file://"),p.onload=function(){if((p.status<200||p.status>=300)&&!(b&&p.status===0)){r.reject(new dt(p.status,p.response,p.getAllResponseHeaders()));return}let g=p.response,w=p.responseType;if(n==="HEAD"||n==="OPTIONS"){let R=p.getAllResponseHeaders().trim().split(/[\r\n]+/),I={};R.forEach(function(T){let M=T.split(": "),U=M.shift();I[U]=M.join(": ")}),r.resolve(I);return}if(p.status===204)r.resolve(void 0);else if(d(g)&&(!d(t)||w===t))r.resolve(g);else if(t==="json"&&typeof g=="string")try{r.resolve(JSON.parse(g))}catch(x){r.reject(x)}else(w===""||w==="document")&&d(p.responseXML)&&p.responseXML.hasChildNodes()?r.resolve(p.responseXML):(w===""||w==="text")&&d(p.responseText)?r.resolve(p.responseText):r.reject(new Re("Invalid XMLHttpRequest response type."))},p.onerror=function(g){r.reject(new dt)},p.send(i),p};E._Implementations.loadAndExecuteScript=function(e,t,n){return xr(e,t).catch(function(i){n.reject(i)})};E._DefaultImplementations={};E._DefaultImplementations.createImage=E._Implementations.createImage;E._DefaultImplementations.loadWithXhr=E._Implementations.loadWithXhr;E._DefaultImplementations.loadAndExecuteScript=E._Implementations.loadAndExecuteScript;E.DEFAULT=Object.freeze(new E({url:typeof document>"u"?"":document.location.href.split("?")[0]}));var ke=E;function yt(e){e=O(e,O.EMPTY_OBJECT),this._dates=void 0,this._samples=void 0,this._dateColumn=-1,this._xPoleWanderRadiansColumn=-1,this._yPoleWanderRadiansColumn=-1,this._ut1MinusUtcSecondsColumn=-1,this._xCelestialPoleOffsetRadiansColumn=-1,this._yCelestialPoleOffsetRadiansColumn=-1,this._taiMinusUtcSecondsColumn=-1,this._columnCount=0,this._lastIndex=-1,this._addNewLeapSeconds=O(e.addNewLeapSeconds,!0),d(e.data)?Fr(this,e.data):Fr(this,{columnNames:["dateIso8601","modifiedJulianDateUtc","xPoleWanderRadians","yPoleWanderRadians","ut1MinusUtcSeconds","lengthOfDayCorrectionSeconds","xCelestialPoleOffsetRadians","yCelestialPoleOffsetRadians","taiMinusUtcSeconds"],samples:[]})}yt.fromUrl=async function(e,t){h.defined("url",e),t=O(t,O.EMPTY_OBJECT);let n=ke.createIfNeeded(e),i;try{i=await n.fetchJson()}catch{throw new Re(`An error occurred while retrieving the EOP data from the URL ${n.url}.`)}return new yt({addNewLeapSeconds:t.addNewLeapSeconds,data:i})};yt.NONE=Object.freeze({compute:function(e,t){return d(t)?(t.xPoleWander=0,t.yPoleWander=0,t.xPoleOffset=0,t.yPoleOffset=0,t.ut1MinusUtc=0):t=new ut(0,0,0,0,0),t}});yt.prototype.compute=function(e,t){if(!d(this._samples))return;if(d(t)||(t=new ut(0,0,0,0,0)),this._samples.length===0)return t.xPoleWander=0,t.yPoleWander=0,t.xPoleOffset=0,t.yPoleOffset=0,t.ut1MinusUtc=0,t;let n=this._dates,i=this._lastIndex,s=0,r=0;if(d(i)){let u=n[i],p=n[i+1],b=ue.lessThanOrEquals(u,e),g=!d(p),w=g||ue.greaterThanOrEquals(p,e);if(b&&w)return s=i,!g&&p.equals(e)&&++s,r=s+1,Nr(this,n,this._samples,e,s,r,t),t}let c=Qe(n,e,ue.compare,this._dateColumn);return c>=0?(c<n.length-1&&n[c+1].equals(e)&&++c,s=c,r=c):(r=~c,s=r-1,s<0&&(s=0)),this._lastIndex=s,Nr(this,n,this._samples,e,s,r,t),t};function Ri(e,t){return ue.compare(e.julianDate,t)}function Fr(e,t){if(!d(t.columnNames))throw new Re("Error in loaded EOP data: The columnNames property is required.");if(!d(t.samples))throw new Re("Error in loaded EOP data: The samples property is required.");let n=t.columnNames.indexOf("modifiedJulianDateUtc"),i=t.columnNames.indexOf("xPoleWanderRadians"),s=t.columnNames.indexOf("yPoleWanderRadians"),r=t.columnNames.indexOf("ut1MinusUtcSeconds"),c=t.columnNames.indexOf("xCelestialPoleOffsetRadians"),u=t.columnNames.indexOf("yCelestialPoleOffsetRadians"),p=t.columnNames.indexOf("taiMinusUtcSeconds");if(n<0||i<0||s<0||r<0||c<0||u<0||p<0)throw new Re("Error in loaded EOP data: The columnNames property must include modifiedJulianDateUtc, xPoleWanderRadians, yPoleWanderRadians, ut1MinusUtcSeconds, xCelestialPoleOffsetRadians, yCelestialPoleOffsetRadians, and taiMinusUtcSeconds columns");let b=e._samples=t.samples,g=e._dates=[];e._dateColumn=n,e._xPoleWanderRadiansColumn=i,e._yPoleWanderRadiansColumn=s,e._ut1MinusUtcSecondsColumn=r,e._xCelestialPoleOffsetRadiansColumn=c,e._yCelestialPoleOffsetRadiansColumn=u,e._taiMinusUtcSecondsColumn=p,e._columnCount=t.columnNames.length,e._lastIndex=void 0;let w,x=e._addNewLeapSeconds;for(let R=0,I=b.length;R<I;R+=e._columnCount){let T=b[R+n],M=b[R+p],U=T+K.MODIFIED_JULIAN_DATE_DIFFERENCE,k=new ue(U,M,N.TAI);if(g.push(k),x){if(M!==w&&d(w)){let q=ue.leapSeconds,F=Qe(q,k,Ri);if(F<0){let j=new Z(k,M);q.splice(~F,0,j)}}w=M}}}function jr(e,t,n,i,s){let r=n*i;s.xPoleWander=t[r+e._xPoleWanderRadiansColumn],s.yPoleWander=t[r+e._yPoleWanderRadiansColumn],s.xPoleOffset=t[r+e._xCelestialPoleOffsetRadiansColumn],s.yPoleOffset=t[r+e._yCelestialPoleOffsetRadiansColumn],s.ut1MinusUtc=t[r+e._ut1MinusUtcSecondsColumn]}function ht(e,t,n){return t+e*(n-t)}function Nr(e,t,n,i,s,r,c){let u=e._columnCount;if(r>t.length-1)return c.xPoleWander=0,c.yPoleWander=0,c.xPoleOffset=0,c.yPoleOffset=0,c.ut1MinusUtc=0,c;let p=t[s],b=t[r];if(p.equals(b)||i.equals(p))return jr(e,n,s,u,c),c;if(i.equals(b))return jr(e,n,r,u,c),c;let g=ue.secondsDifference(i,p)/ue.secondsDifference(b,p),w=s*u,x=r*u,R=n[w+e._ut1MinusUtcSecondsColumn],I=n[x+e._ut1MinusUtcSecondsColumn],T=I-R;if(T>.5||T<-.5){let M=n[w+e._taiMinusUtcSecondsColumn],U=n[x+e._taiMinusUtcSecondsColumn];M!==U&&(b.equals(i)?R=I:I-=U-M)}return c.xPoleWander=ht(g,n[w+e._xPoleWanderRadiansColumn],n[x+e._xPoleWanderRadiansColumn]),c.yPoleWander=ht(g,n[w+e._yPoleWanderRadiansColumn],n[x+e._yPoleWanderRadiansColumn]),c.xPoleOffset=ht(g,n[w+e._xCelestialPoleOffsetRadiansColumn],n[x+e._xCelestialPoleOffsetRadiansColumn]),c.yPoleOffset=ht(g,n[w+e._yCelestialPoleOffsetRadiansColumn],n[x+e._yCelestialPoleOffsetRadiansColumn]),c.ut1MinusUtc=ht(g,R,I),c}var Br=yt;function de(e,t,n){this.heading=O(e,0),this.pitch=O(t,0),this.roll=O(n,0)}de.fromQuaternion=function(e,t){if(!d(e))throw new A("quaternion is required");d(t)||(t=new de);let n=2*(e.w*e.y-e.z*e.x),i=1-2*(e.x*e.x+e.y*e.y),s=2*(e.w*e.x+e.y*e.z),r=1-2*(e.y*e.y+e.z*e.z),c=2*(e.w*e.z+e.x*e.y);return t.heading=-Math.atan2(c,r),t.roll=Math.atan2(s,i),t.pitch=-X.asinClamped(n),t};de.fromDegrees=function(e,t,n,i){if(!d(e))throw new A("heading is required");if(!d(t))throw new A("pitch is required");if(!d(n))throw new A("roll is required");return d(i)||(i=new de),i.heading=e*X.RADIANS_PER_DEGREE,i.pitch=t*X.RADIANS_PER_DEGREE,i.roll=n*X.RADIANS_PER_DEGREE,i};de.clone=function(e,t){if(d(e))return d(t)?(t.heading=e.heading,t.pitch=e.pitch,t.roll=e.roll,t):new de(e.heading,e.pitch,e.roll)};de.equals=function(e,t){return e===t||d(e)&&d(t)&&e.heading===t.heading&&e.pitch===t.pitch&&e.roll===t.roll};de.equalsEpsilon=function(e,t,n,i){return e===t||d(e)&&d(t)&&X.equalsEpsilon(e.heading,t.heading,n,i)&&X.equalsEpsilon(e.pitch,t.pitch,n,i)&&X.equalsEpsilon(e.roll,t.roll,n,i)};de.prototype.clone=function(e){return de.clone(this,e)};de.prototype.equals=function(e){return de.equals(this,e)};de.prototype.equalsEpsilon=function(e,t,n){return de.equalsEpsilon(this,e,t,n)};de.prototype.toString=function(){return`(${this.heading}, ${this.pitch}, ${this.roll})`};var In=de;var Lr=/((?:.*\/)|^)Cesium\.js(?:\?|\#|$)/;function Pi(){let e=document.getElementsByTagName("script");for(let t=0,n=e.length;t<n;++t){let i=e[t].getAttribute("src"),s=Lr.exec(i);if(s!==null)return s[1]}}var Qt;function Qr(e){return typeof document>"u"?e:(d(Qt)||(Qt=document.createElement("a")),Qt.href=e,Qt.href)}var Ye;function $r(){if(d(Ye))return Ye;let e;if(typeof CESIUM_BASE_URL<"u"?e=CESIUM_BASE_URL:d(import.meta?.url)?e=lt(".",import.meta.url):typeof define=="object"&&d(define.amd)&&!define.amd.toUrlUndefined&&d(xt.toUrl)?e=lt("..",Ze("Core/buildModuleUrl.js")):e=Pi(),!d(e))throw new A("Unable to determine Cesium base URL automatically, try defining a global variable called CESIUM_BASE_URL.");return Ye=new ke({url:Qr(e)}),Ye.appendForwardSlash(),Ye}function Ti(e){return Qr(xt.toUrl(`../${e}`))}function Hr(e){return $r().getDerivedResource({url:e}).url}var $t;function Ze(e){return d($t)||(typeof define=="object"&&d(define.amd)&&!define.amd.toUrlUndefined&&d(xt.toUrl)?$t=Ti:$t=Hr),$t(e)}Ze._cesiumScriptRegex=Lr;Ze._buildModuleUrlFromBaseUrl=Hr;Ze._clearBaseResource=function(){Ye=void 0};Ze.setBaseUrl=function(e){Ye=ke.DEFAULT.getDerivedResource({url:e})};Ze.getCesiumBaseUrl=$r;var Wr=Ze;function Ii(e,t,n){this.x=e,this.y=t,this.s=n}var Ht=Ii;function qn(e){e=O(e,O.EMPTY_OBJECT),this._xysFileUrlTemplate=ke.createIfNeeded(e.xysFileUrlTemplate),this._interpolationOrder=O(e.interpolationOrder,9),this._sampleZeroJulianEphemerisDate=O(e.sampleZeroJulianEphemerisDate,24423965e-1),this._sampleZeroDateTT=new ue(this._sampleZeroJulianEphemerisDate,0,N.TAI),this._stepSizeDays=O(e.stepSizeDays,1),this._samplesPerXysFile=O(e.samplesPerXysFile,1e3),this._totalSamples=O(e.totalSamples,27426),this._samples=new Array(this._totalSamples*3),this._chunkDownloadsInProgress=[];let t=this._interpolationOrder,n=this._denominators=new Array(t+1),i=this._xTable=new Array(t+1),s=Math.pow(this._stepSizeDays,t);for(let r=0;r<=t;++r){n[r]=s,i[r]=r*this._stepSizeDays;for(let c=0;c<=t;++c)c!==r&&(n[r]*=r-c);n[r]=1/n[r]}this._work=new Array(t+1),this._coef=new Array(t+1)}var Ui=new ue(0,0,N.TAI);function Un(e,t,n){let i=Ui;return i.dayNumber=t,i.secondsOfDay=n,ue.daysDifference(i,e._sampleZeroDateTT)}qn.prototype.preload=function(e,t,n,i){let s=Un(this,e,t),r=Un(this,n,i),c=s/this._stepSizeDays-this._interpolationOrder/2|0;c<0&&(c=0);let u=r/this._stepSizeDays-this._interpolationOrder/2|0+this._interpolationOrder;u>=this._totalSamples&&(u=this._totalSamples-1);let p=c/this._samplesPerXysFile|0,b=u/this._samplesPerXysFile|0,g=[];for(let w=p;w<=b;++w)g.push(Dn(this,w));return Promise.all(g)};qn.prototype.computeXysRadians=function(e,t,n){let i=Un(this,e,t);if(i<0)return;let s=i/this._stepSizeDays|0;if(s>=this._totalSamples)return;let r=this._interpolationOrder,c=s-(r/2|0);c<0&&(c=0);let u=c+r;u>=this._totalSamples&&(u=this._totalSamples-1,c=u-r,c<0&&(c=0));let p=!1,b=this._samples;if(d(b[c*3])||(Dn(this,c/this._samplesPerXysFile|0),p=!0),d(b[u*3])||(Dn(this,u/this._samplesPerXysFile|0),p=!0),p)return;d(n)?(n.x=0,n.y=0,n.s=0):n=new Ht(0,0,0);let g=i-c*this._stepSizeDays,w=this._work,x=this._denominators,R=this._coef,I=this._xTable,T,M;for(T=0;T<=r;++T)w[T]=g-I[T];for(T=0;T<=r;++T){for(R[T]=1,M=0;M<=r;++M)M!==T&&(R[T]*=w[M]);R[T]*=x[T];let U=(c+T)*3;n.x+=R[T]*b[U++],n.y+=R[T]*b[U++],n.s+=R[T]*b[U]}return n};function Dn(e,t){if(e._chunkDownloadsInProgress[t])return e._chunkDownloadsInProgress[t];let n,i=e._xysFileUrlTemplate;d(i)?n=i.getDerivedResource({templateValues:{0:t}}):n=new ke({url:Wr(`Assets/IAU2006_XYS/IAU2006_XYS_${t}.json`)});let s=n.fetchJson().then(function(r){e._chunkDownloadsInProgress[t]=!1;let c=e._samples,u=r.samples,p=t*e._samplesPerXysFile*3;for(let b=0,g=u.length;b<g;++b)c[p+b]=u[b]});return e._chunkDownloadsInProgress[t]=s,s}var Vr=qn;var Fe,re={requestFullscreen:void 0,exitFullscreen:void 0,fullscreenEnabled:void 0,fullscreenElement:void 0,fullscreenchange:void 0,fullscreenerror:void 0},ge={};Object.defineProperties(ge,{element:{get:function(){if(ge.supportsFullscreen())return document[re.fullscreenElement]}},changeEventName:{get:function(){if(ge.supportsFullscreen())return re.fullscreenchange}},errorEventName:{get:function(){if(ge.supportsFullscreen())return re.fullscreenerror}},enabled:{get:function(){if(ge.supportsFullscreen())return document[re.fullscreenEnabled]}},fullscreen:{get:function(){if(ge.supportsFullscreen())return ge.element!==null}}});ge.supportsFullscreen=function(){if(d(Fe))return Fe;Fe=!1;let e=document.body;if(typeof e.requestFullscreen=="function")return re.requestFullscreen="requestFullscreen",re.exitFullscreen="exitFullscreen",re.fullscreenEnabled="fullscreenEnabled",re.fullscreenElement="fullscreenElement",re.fullscreenchange="fullscreenchange",re.fullscreenerror="fullscreenerror",Fe=!0,Fe;let t=["webkit","moz","o","ms","khtml"],n;for(let i=0,s=t.length;i<s;++i){let r=t[i];n=`${r}RequestFullscreen`,typeof e[n]=="function"?(re.requestFullscreen=n,Fe=!0):(n=`${r}RequestFullScreen`,typeof e[n]=="function"&&(re.requestFullscreen=n,Fe=!0)),n=`${r}ExitFullscreen`,typeof document[n]=="function"?re.exitFullscreen=n:(n=`${r}CancelFullScreen`,typeof document[n]=="function"&&(re.exitFullscreen=n)),n=`${r}FullscreenEnabled`,document[n]!==void 0?re.fullscreenEnabled=n:(n=`${r}FullScreenEnabled`,document[n]!==void 0&&(re.fullscreenEnabled=n)),n=`${r}FullscreenElement`,document[n]!==void 0?re.fullscreenElement=n:(n=`${r}FullScreenElement`,document[n]!==void 0&&(re.fullscreenElement=n)),n=`${r}fullscreenchange`,document[`on${n}`]!==void 0&&(r==="ms"&&(n="MSFullscreenChange"),re.fullscreenchange=n),n=`${r}fullscreenerror`,document[`on${n}`]!==void 0&&(r==="ms"&&(n="MSFullscreenError"),re.fullscreenerror=n)}return Fe};ge.requestFullscreen=function(e,t){ge.supportsFullscreen()&&e[re.requestFullscreen]({vrDisplay:t})};ge.exitFullscreen=function(){ge.supportsFullscreen()&&document[re.exitFullscreen]()};ge._names=re;var Yr=ge;var me;typeof navigator<"u"?me=navigator:me={};function Xe(e){let t=e.split(".");for(let n=0,i=t.length;n<i;++n)t[n]=parseInt(t[n],10);return t}var Wt,Zr;function Nn(){if(!d(Wt)&&(Wt=!1,!Gt())){let e=/ Chrome\/([\.0-9]+)/.exec(me.userAgent);e!==null&&(Wt=!0,Zr=Xe(e[1]))}return Wt}function Di(){return Nn()&&Zr}var Vt,Xr;function Jr(){if(!d(Vt)&&(Vt=!1,!Nn()&&!Gt()&&/ Safari\/[\.0-9]+/.test(me.userAgent))){let e=/ Version\/([\.0-9]+)/.exec(me.userAgent);e!==null&&(Vt=!0,Xr=Xe(e[1]))}return Vt}function qi(){return Jr()&&Xr}var Yt,Fn;function Gr(){if(!d(Yt)){Yt=!1;let e=/ AppleWebKit\/([\.0-9]+)(\+?)/.exec(me.userAgent);e!==null&&(Yt=!0,Fn=Xe(e[1]),Fn.isNightly=!!e[2])}return Yt}function zi(){return Gr()&&Fn}var gt,jn;function Kr(){if(!d(gt)){gt=!1;let e;me.appName==="Microsoft Internet Explorer"?(e=/MSIE ([0-9]{1,}[\.0-9]{0,})/.exec(me.userAgent),e!==null&&(gt=!0,jn=Xe(e[1]))):me.appName==="Netscape"&&(e=/Trident\/.*rv:([0-9]{1,}[\.0-9]{0,})/.exec(me.userAgent),e!==null&&(gt=!0,jn=Xe(e[1])))}return gt}function Mi(){return Kr()&&jn}var Zt,eo;function Gt(){if(!d(Zt)){Zt=!1;let e=/ Edg\/([\.0-9]+)/.exec(me.userAgent);e!==null&&(Zt=!0,eo=Xe(e[1]))}return Zt}function ki(){return Gt()&&eo}var Xt,Bn;function Kt(){if(!d(Xt)){Xt=!1;let e=/Firefox\/([\.0-9]+)/.exec(me.userAgent);e!==null&&(Xt=!0,Bn=Xe(e[1]))}return Xt}var zn;function Fi(){return d(zn)||(zn=/Windows/i.test(me.appVersion)),zn}var Mn;function ji(){return d(Mn)||(Mn=navigator.platform==="iPhone"||navigator.platform==="iPod"||navigator.platform==="iPad"),Mn}function Ni(){return Kt()&&Bn}var kn;function Bi(){return d(kn)||(kn=!Kt()&&typeof PointerEvent<"u"&&(!d(me.pointerEnabled)||me.pointerEnabled)),kn}var to,Jt;function no(){if(!d(Jt)){let e=document.createElement("canvas");e.setAttribute("style","image-rendering: -moz-crisp-edges;image-rendering: pixelated;");let t=e.style.imageRendering;Jt=d(t)&&t!=="",Jt&&(to=t)}return Jt}function Li(){return no()?to:void 0}function pe(){if(!pe.initialized)throw new A("You must call FeatureDetection.supportsWebP.initialize and wait for the promise to resolve before calling FeatureDetection.supportsWebP");return pe._result}pe._promise=void 0;pe._result=void 0;pe.initialize=function(){return d(pe._promise)||(pe._promise=new Promise(e=>{let t=new Image;t.onload=function(){pe._result=t.width>0&&t.height>0,e(pe._result)},t.onerror=function(){pe._result=!1,e(pe._result)},t.src="data:image/webp;base64,UklGRiIAAABXRUJQVlA4IBYAAAAwAQCdASoBAAEADsD+JaQAA3AAAAAA"})),pe._promise};Object.defineProperties(pe,{initialized:{get:function(){return d(pe._result)}}});var st=[];typeof ArrayBuffer<"u"&&(st.push(Int8Array,Uint8Array,Int16Array,Uint16Array,Int32Array,Uint32Array,Float32Array,Float64Array),typeof Uint8ClampedArray<"u"&&st.push(Uint8ClampedArray),typeof Uint8ClampedArray<"u"&&st.push(Uint8ClampedArray),typeof BigInt64Array<"u"&&st.push(BigInt64Array),typeof BigUint64Array<"u"&&st.push(BigUint64Array));var xe={isChrome:Nn,chromeVersion:Di,isSafari:Jr,safariVersion:qi,isWebkit:Gr,webkitVersion:zi,isInternetExplorer:Kr,internetExplorerVersion:Mi,isEdge:Gt,edgeVersion:ki,isFirefox:Kt,firefoxVersion:Ni,isWindows:Fi,isIPadOrIOS:ji,hardwareConcurrency:O(me.hardwareConcurrency,3),supportsPointerEvents:Bi,supportsImageRenderingPixelated:no,supportsWebP:pe,imageRenderingValue:Li,typedArrayTypes:st};xe.supportsBasis=function(e){return xe.supportsWebAssembly()&&e.context.supportsBasis};xe.supportsFullscreen=function(){return Yr.supportsFullscreen()};xe.supportsTypedArrays=function(){return typeof ArrayBuffer<"u"};xe.supportsBigInt64Array=function(){return typeof BigInt64Array<"u"};xe.supportsBigUint64Array=function(){return typeof BigUint64Array<"u"};xe.supportsBigInt=function(){return typeof BigInt<"u"};xe.supportsWebWorkers=function(){return typeof Worker<"u"};xe.supportsWebAssembly=function(){return typeof WebAssembly<"u"};xe.supportsWebgl2=function(e){return h.defined("scene",e),e.context.webgl2};xe.supportsEsmWebWorkers=function(){return!Kt()||parseInt(Bn)>=114};var wt=xe;function S(e,t,n,i){this.x=O(e,0),this.y=O(t,0),this.z=O(n,0),this.w=O(i,0)}var bt=new f;S.fromAxisAngle=function(e,t,n){h.typeOf.object("axis",e),h.typeOf.number("angle",t);let i=t/2,s=Math.sin(i);bt=f.normalize(e,bt);let r=bt.x*s,c=bt.y*s,u=bt.z*s,p=Math.cos(i);return d(n)?(n.x=r,n.y=c,n.z=u,n.w=p,n):new S(r,c,u,p)};var Qi=[1,2,0],$i=new Array(3);S.fromRotationMatrix=function(e,t){h.typeOf.object("matrix",e);let n,i,s,r,c,u=e[B.COLUMN0ROW0],p=e[B.COLUMN1ROW1],b=e[B.COLUMN2ROW2],g=u+p+b;if(g>0)n=Math.sqrt(g+1),c=.5*n,n=.5/n,i=(e[B.COLUMN1ROW2]-e[B.COLUMN2ROW1])*n,s=(e[B.COLUMN2ROW0]-e[B.COLUMN0ROW2])*n,r=(e[B.COLUMN0ROW1]-e[B.COLUMN1ROW0])*n;else{let w=Qi,x=0;p>u&&(x=1),b>u&&b>p&&(x=2);let R=w[x],I=w[R];n=Math.sqrt(e[B.getElementIndex(x,x)]-e[B.getElementIndex(R,R)]-e[B.getElementIndex(I,I)]+1);let T=$i;T[x]=.5*n,n=.5/n,c=(e[B.getElementIndex(I,R)]-e[B.getElementIndex(R,I)])*n,T[R]=(e[B.getElementIndex(R,x)]+e[B.getElementIndex(x,R)])*n,T[I]=(e[B.getElementIndex(I,x)]+e[B.getElementIndex(x,I)])*n,i=-T[0],s=-T[1],r=-T[2]}return d(t)?(t.x=i,t.y=s,t.z=r,t.w=c,t):new S(i,s,r,c)};var ro=new S,oo=new S,Ln=new S,io=new S;S.fromHeadingPitchRoll=function(e,t){return h.typeOf.object("headingPitchRoll",e),io=S.fromAxisAngle(f.UNIT_X,e.roll,ro),Ln=S.fromAxisAngle(f.UNIT_Y,-e.pitch,t),t=S.multiply(Ln,io,Ln),oo=S.fromAxisAngle(f.UNIT_Z,-e.heading,ro),S.multiply(oo,t,t)};var en=new f,Qn=new f,ve=new S,so=new S,tn=new S;S.packedLength=4;S.pack=function(e,t,n){return h.typeOf.object("value",e),h.defined("array",t),n=O(n,0),t[n++]=e.x,t[n++]=e.y,t[n++]=e.z,t[n]=e.w,t};S.unpack=function(e,t,n){return h.defined("array",e),t=O(t,0),d(n)||(n=new S),n.x=e[t],n.y=e[t+1],n.z=e[t+2],n.w=e[t+3],n};S.packedInterpolationLength=3;S.convertPackedArrayForInterpolation=function(e,t,n,i){S.unpack(e,n*4,tn),S.conjugate(tn,tn);for(let s=0,r=n-t+1;s<r;s++){let c=s*3;S.unpack(e,(t+s)*4,ve),S.multiply(ve,tn,ve),ve.w<0&&S.negate(ve,ve),S.computeAxis(ve,en);let u=S.computeAngle(ve);d(i)||(i=[]),i[c]=en.x*u,i[c+1]=en.y*u,i[c+2]=en.z*u}};S.unpackInterpolationResult=function(e,t,n,i,s){d(s)||(s=new S),f.fromArray(e,0,Qn);let r=f.magnitude(Qn);return S.unpack(t,i*4,so),r===0?S.clone(S.IDENTITY,ve):S.fromAxisAngle(Qn,r,ve),S.multiply(ve,so,s)};S.clone=function(e,t){if(d(e))return d(t)?(t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t):new S(e.x,e.y,e.z,e.w)};S.conjugate=function(e,t){return h.typeOf.object("quaternion",e),h.typeOf.object("result",t),t.x=-e.x,t.y=-e.y,t.z=-e.z,t.w=e.w,t};S.magnitudeSquared=function(e){return h.typeOf.object("quaternion",e),e.x*e.x+e.y*e.y+e.z*e.z+e.w*e.w};S.magnitude=function(e){return Math.sqrt(S.magnitudeSquared(e))};S.normalize=function(e,t){h.typeOf.object("result",t);let n=1/S.magnitude(e),i=e.x*n,s=e.y*n,r=e.z*n,c=e.w*n;return t.x=i,t.y=s,t.z=r,t.w=c,t};S.inverse=function(e,t){h.typeOf.object("result",t);let n=S.magnitudeSquared(e);return t=S.conjugate(e,t),S.multiplyByScalar(t,1/n,t)};S.add=function(e,t,n){return h.typeOf.object("left",e),h.typeOf.object("right",t),h.typeOf.object("result",n),n.x=e.x+t.x,n.y=e.y+t.y,n.z=e.z+t.z,n.w=e.w+t.w,n};S.subtract=function(e,t,n){return h.typeOf.object("left",e),h.typeOf.object("right",t),h.typeOf.object("result",n),n.x=e.x-t.x,n.y=e.y-t.y,n.z=e.z-t.z,n.w=e.w-t.w,n};S.negate=function(e,t){return h.typeOf.object("quaternion",e),h.typeOf.object("result",t),t.x=-e.x,t.y=-e.y,t.z=-e.z,t.w=-e.w,t};S.dot=function(e,t){return h.typeOf.object("left",e),h.typeOf.object("right",t),e.x*t.x+e.y*t.y+e.z*t.z+e.w*t.w};S.multiply=function(e,t,n){h.typeOf.object("left",e),h.typeOf.object("right",t),h.typeOf.object("result",n);let i=e.x,s=e.y,r=e.z,c=e.w,u=t.x,p=t.y,b=t.z,g=t.w,w=c*u+i*g+s*b-r*p,x=c*p-i*b+s*g+r*u,R=c*b+i*p-s*u+r*g,I=c*g-i*u-s*p-r*b;return n.x=w,n.y=x,n.z=R,n.w=I,n};S.multiplyByScalar=function(e,t,n){return h.typeOf.object("quaternion",e),h.typeOf.number("scalar",t),h.typeOf.object("result",n),n.x=e.x*t,n.y=e.y*t,n.z=e.z*t,n.w=e.w*t,n};S.divideByScalar=function(e,t,n){return h.typeOf.object("quaternion",e),h.typeOf.number("scalar",t),h.typeOf.object("result",n),n.x=e.x/t,n.y=e.y/t,n.z=e.z/t,n.w=e.w/t,n};S.computeAxis=function(e,t){h.typeOf.object("quaternion",e),h.typeOf.object("result",t);let n=e.w;if(Math.abs(n-1)<X.EPSILON6||Math.abs(n+1)<X.EPSILON6)return t.x=1,t.y=t.z=0,t;let i=1/Math.sqrt(1-n*n);return t.x=e.x*i,t.y=e.y*i,t.z=e.z*i,t};S.computeAngle=function(e){return h.typeOf.object("quaternion",e),Math.abs(e.w-1)<X.EPSILON6?0:2*Math.acos(e.w)};var $n=new S;S.lerp=function(e,t,n,i){return h.typeOf.object("start",e),h.typeOf.object("end",t),h.typeOf.number("t",n),h.typeOf.object("result",i),$n=S.multiplyByScalar(t,n,$n),i=S.multiplyByScalar(e,1-n,i),S.add($n,i,i)};var ao=new S,Hn=new S,Wn=new S;S.slerp=function(e,t,n,i){h.typeOf.object("start",e),h.typeOf.object("end",t),h.typeOf.number("t",n),h.typeOf.object("result",i);let s=S.dot(e,t),r=t;if(s<0&&(s=-s,r=ao=S.negate(t,ao)),1-s<X.EPSILON6)return S.lerp(e,r,n,i);let c=Math.acos(s);return Hn=S.multiplyByScalar(e,Math.sin((1-n)*c),Hn),Wn=S.multiplyByScalar(r,Math.sin(n*c),Wn),i=S.add(Hn,Wn,i),S.multiplyByScalar(i,1/Math.sin(c),i)};S.log=function(e,t){h.typeOf.object("quaternion",e),h.typeOf.object("result",t);let n=X.acosClamped(e.w),i=0;return n!==0&&(i=n/Math.sin(n)),f.multiplyByScalar(e,i,t)};S.exp=function(e,t){h.typeOf.object("cartesian",e),h.typeOf.object("result",t);let n=f.magnitude(e),i=0;return n!==0&&(i=Math.sin(n)/n),t.x=e.x*i,t.y=e.y*i,t.z=e.z*i,t.w=Math.cos(n),t};var Hi=new f,Wi=new f,_t=new S,at=new S;S.computeInnerQuadrangle=function(e,t,n,i){h.typeOf.object("q0",e),h.typeOf.object("q1",t),h.typeOf.object("q2",n),h.typeOf.object("result",i);let s=S.conjugate(t,_t);S.multiply(s,n,at);let r=S.log(at,Hi);S.multiply(s,e,at);let c=S.log(at,Wi);return f.add(r,c,r),f.multiplyByScalar(r,.25,r),f.negate(r,r),S.exp(r,_t),S.multiply(t,_t,i)};S.squad=function(e,t,n,i,s,r){h.typeOf.object("q0",e),h.typeOf.object("q1",t),h.typeOf.object("s0",n),h.typeOf.object("s1",i),h.typeOf.number("t",s),h.typeOf.object("result",r);let c=S.slerp(e,t,s,_t),u=S.slerp(n,i,s,at);return S.slerp(c,u,2*s*(1-s),r)};var Vi=new S,co=1.9011074535173003,nn=wt.supportsTypedArrays()?new Float32Array(8):[],rn=wt.supportsTypedArrays()?new Float32Array(8):[],Te=wt.supportsTypedArrays()?new Float32Array(8):[],Ie=wt.supportsTypedArrays()?new Float32Array(8):[];for(let e=0;e<7;++e){let t=e+1,n=2*t+1;nn[e]=1/(t*n),rn[e]=t/n}nn[7]=co/(8*17);rn[7]=co*8/17;S.fastSlerp=function(e,t,n,i){h.typeOf.object("start",e),h.typeOf.object("end",t),h.typeOf.number("t",n),h.typeOf.object("result",i);let s=S.dot(e,t),r;s>=0?r=1:(r=-1,s=-s);let c=s-1,u=1-n,p=n*n,b=u*u;for(let R=7;R>=0;--R)Te[R]=(nn[R]*p-rn[R])*c,Ie[R]=(nn[R]*b-rn[R])*c;let g=r*n*(1+Te[0]*(1+Te[1]*(1+Te[2]*(1+Te[3]*(1+Te[4]*(1+Te[5]*(1+Te[6]*(1+Te[7])))))))),w=u*(1+Ie[0]*(1+Ie[1]*(1+Ie[2]*(1+Ie[3]*(1+Ie[4]*(1+Ie[5]*(1+Ie[6]*(1+Ie[7])))))))),x=S.multiplyByScalar(e,w,Vi);return S.multiplyByScalar(t,g,i),S.add(x,i,i)};S.fastSquad=function(e,t,n,i,s,r){h.typeOf.object("q0",e),h.typeOf.object("q1",t),h.typeOf.object("s0",n),h.typeOf.object("s1",i),h.typeOf.number("t",s),h.typeOf.object("result",r);let c=S.fastSlerp(e,t,s,_t),u=S.fastSlerp(n,i,s,at);return S.fastSlerp(c,u,2*s*(1-s),r)};S.equals=function(e,t){return e===t||d(e)&&d(t)&&e.x===t.x&&e.y===t.y&&e.z===t.z&&e.w===t.w};S.equalsEpsilon=function(e,t,n){return n=O(n,0),e===t||d(e)&&d(t)&&Math.abs(e.x-t.x)<=n&&Math.abs(e.y-t.y)<=n&&Math.abs(e.z-t.z)<=n&&Math.abs(e.w-t.w)<=n};S.ZERO=Object.freeze(new S(0,0,0,0));S.IDENTITY=Object.freeze(new S(0,0,0,1));S.prototype.clone=function(e){return S.clone(this,e)};S.prototype.equals=function(e){return S.equals(this,e)};S.prototype.equalsEpsilon=function(e,t){return S.equalsEpsilon(this,e,t)};S.prototype.toString=function(){return`(${this.x}, ${this.y}, ${this.z}, ${this.w})`};var Je=S;var $={},Vn={up:{south:"east",north:"west",west:"south",east:"north"},down:{south:"west",north:"east",west:"north",east:"south"},south:{up:"west",down:"east",west:"down",east:"up"},north:{up:"east",down:"west",west:"up",east:"down"},west:{up:"north",down:"south",north:"down",south:"up"},east:{up:"south",down:"north",north:"up",south:"down"}},ct={north:[-1,0,0],east:[0,1,0],up:[0,0,1],south:[1,0,0],west:[0,-1,0],down:[0,0,-1]},Yn={},we={east:new f,north:new f,up:new f,west:new f,south:new f,down:new f},je=new f,Ne=new f,Be=new f;$.localFrameToFixedFrameGenerator=function(e,t){if(!Vn.hasOwnProperty(e)||!Vn[e].hasOwnProperty(t))throw new A("firstAxis and secondAxis must be east, north, up, west, south or down.");let n=Vn[e][t],i,s=e+t;return d(Yn[s])?i=Yn[s]:(i=function(r,c,u){if(!d(r))throw new A("origin is required.");if(d(u)||(u=new L),f.equalsEpsilon(r,f.ZERO,X.EPSILON14))f.unpack(ct[e],0,je),f.unpack(ct[t],0,Ne),f.unpack(ct[n],0,Be);else if(X.equalsEpsilon(r.x,0,X.EPSILON14)&&X.equalsEpsilon(r.y,0,X.EPSILON14)){let p=X.sign(r.z);f.unpack(ct[e],0,je),e!=="east"&&e!=="west"&&f.multiplyByScalar(je,p,je),f.unpack(ct[t],0,Ne),t!=="east"&&t!=="west"&&f.multiplyByScalar(Ne,p,Ne),f.unpack(ct[n],0,Be),n!=="east"&&n!=="west"&&f.multiplyByScalar(Be,p,Be)}else{c=O(c,qe.WGS84),c.geodeticSurfaceNormal(r,we.up);let p=we.up,b=we.east;b.x=-r.y,b.y=r.x,b.z=0,f.normalize(b,we.east),f.cross(p,b,we.north),f.multiplyByScalar(we.up,-1,we.down),f.multiplyByScalar(we.east,-1,we.west),f.multiplyByScalar(we.north,-1,we.south),je=we[e],Ne=we[t],Be=we[n]}return u[0]=je.x,u[1]=je.y,u[2]=je.z,u[3]=0,u[4]=Ne.x,u[5]=Ne.y,u[6]=Ne.z,u[7]=0,u[8]=Be.x,u[9]=Be.y,u[10]=Be.z,u[11]=0,u[12]=r.x,u[13]=r.y,u[14]=r.z,u[15]=1,u},Yn[s]=i),i};$.eastNorthUpToFixedFrame=$.localFrameToFixedFrameGenerator("east","north");$.northEastDownToFixedFrame=$.localFrameToFixedFrameGenerator("north","east");$.northUpEastToFixedFrame=$.localFrameToFixedFrameGenerator("north","up");$.northWestUpToFixedFrame=$.localFrameToFixedFrameGenerator("north","west");var Yi=new Je,Zi=new f(1,1,1),Xi=new L;$.headingPitchRollToFixedFrame=function(e,t,n,i,s){h.typeOf.object("HeadingPitchRoll",t),i=O(i,$.eastNorthUpToFixedFrame);let r=Je.fromHeadingPitchRoll(t,Yi),c=L.fromTranslationQuaternionRotationScale(f.ZERO,r,Zi,Xi);return s=i(e,n,s),L.multiply(s,c,s)};var Ji=new L,Gi=new B;$.headingPitchRollQuaternion=function(e,t,n,i,s){h.typeOf.object("HeadingPitchRoll",t);let r=$.headingPitchRollToFixedFrame(e,t,n,i,Ji),c=L.getMatrix3(r,Gi);return Je.fromRotationMatrix(c,s)};var Ki=new f(1,1,1),es=new f,uo=new L,ts=new L,ns=new B,rs=new Je;$.fixedFrameToHeadingPitchRoll=function(e,t,n,i){h.defined("transform",e),t=O(t,qe.WGS84),n=O(n,$.eastNorthUpToFixedFrame),d(i)||(i=new In);let s=L.getTranslation(e,es);if(f.equals(s,f.ZERO))return i.heading=0,i.pitch=0,i.roll=0,i;let r=L.inverseTransformation(n(s,t,uo),uo),c=L.setScale(e,Ki,ts);c=L.setTranslation(c,f.ZERO,c),r=L.multiply(r,c,r);let u=Je.fromRotationMatrix(L.getMatrix3(r,ns),rs);return u=Je.normalize(u,u),In.fromQuaternion(u,i)};var os=6*3600+41*60+50.54841,is=8640184812866e-6,ss=.093104,as=-62e-7,cs=11772758384668e-32,us=72921158553e-15,fs=X.TWO_PI/86400,on=new ue;$.computeTemeToPseudoFixedMatrix=function(e,t){if(!d(e))throw new A("date is required.");on=ue.addSeconds(e,-ue.computeTaiMinusUtc(e),on);let n=on.dayNumber,i=on.secondsOfDay,s,r=n-2451545;i>=43200?s=(r+.5)/K.DAYS_PER_JULIAN_CENTURY:s=(r-.5)/K.DAYS_PER_JULIAN_CENTURY;let u=(os+s*(is+s*(ss+s*as)))*fs%X.TWO_PI,p=us+cs*(n-24515455e-1),b=(i+K.SECONDS_PER_DAY*.5)%K.SECONDS_PER_DAY,g=u+p*b,w=Math.cos(g),x=Math.sin(g);return d(t)?(t[0]=w,t[1]=-x,t[2]=0,t[3]=x,t[4]=w,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t):new B(w,x,0,-x,w,0,0,0,1)};$.iau2006XysData=new Vr;$.earthOrientationParameters=Br.NONE;var Jn=32.184,ls=2451545;$.preloadIcrfFixed=function(e){let t=e.start.dayNumber,n=e.start.secondsOfDay+Jn,i=e.stop.dayNumber,s=e.stop.secondsOfDay+Jn;return $.iau2006XysData.preload(t,n,i,s)};$.computeIcrfToFixedMatrix=function(e,t){if(!d(e))throw new A("date is required.");d(t)||(t=new B);let n=$.computeFixedToIcrfMatrix(e,t);if(d(n))return B.transpose(n,t)};var ds=new Ht(0,0,0),ps=new ut(0,0,0,0,0,0),Zn=new B,Xn=new B;$.computeFixedToIcrfMatrix=function(e,t){if(!d(e))throw new A("date is required.");d(t)||(t=new B);let n=$.earthOrientationParameters.compute(e,ps);if(!d(n))return;let i=e.dayNumber,s=e.secondsOfDay+Jn,r=$.iau2006XysData.computeXysRadians(i,s,ds);if(!d(r))return;let c=r.x+n.xPoleOffset,u=r.y+n.yPoleOffset,p=1/(1+Math.sqrt(1-c*c-u*u)),b=Zn;b[0]=1-p*c*c,b[3]=-p*c*u,b[6]=c,b[1]=-p*c*u,b[4]=1-p*u*u,b[7]=u,b[2]=-c,b[5]=-u,b[8]=1-p*(c*c+u*u);let g=B.fromRotationZ(-r.s,Xn),w=B.multiply(b,g,Zn),x=e.dayNumber,R=e.secondsOfDay-ue.computeTaiMinusUtc(e)+n.ut1MinusUtc,I=x-2451545,T=R/K.SECONDS_PER_DAY,M=.779057273264+T+.00273781191135448*(I+T);M=M%1*X.TWO_PI;let U=B.fromRotationZ(M,Xn),k=B.multiply(w,U,Zn),q=Math.cos(n.xPoleWander),F=Math.cos(n.yPoleWander),j=Math.sin(n.xPoleWander),H=Math.sin(n.yPoleWander),oe=i-ls+s/K.SECONDS_PER_DAY;oe/=36525;let ie=-47e-6*oe*X.RADIANS_PER_DEGREE/3600,J=Math.cos(ie),W=Math.sin(ie),Q=Xn;return Q[0]=q*J,Q[1]=q*W,Q[2]=j,Q[3]=-F*W+H*j*J,Q[4]=F*J+H*j*W,Q[5]=-H*q,Q[6]=-H*W-F*j*J,Q[7]=H*J-F*j*W,Q[8]=F*q,B.multiply(k,Q,t)};var ms=new Ot;$.pointToWindowCoordinates=function(e,t,n,i){return i=$.pointToGLWindowCoordinates(e,t,n,i),i.y=2*t[5]-i.y,i};$.pointToGLWindowCoordinates=function(e,t,n,i){if(!d(e))throw new A("modelViewProjectionMatrix is required.");if(!d(t))throw new A("viewportTransformation is required.");if(!d(n))throw new A("point is required.");d(i)||(i=new an);let s=ms;return L.multiplyByVector(e,Ot.fromElements(n.x,n.y,n.z,1,s),s),Ot.multiplyByScalar(s,1/s.w,s),L.multiplyByVector(t,s,s),an.fromCartesian4(s,i)};var hs=new f,ys=new f,gs=new f;$.rotationMatrixFromPositionVelocity=function(e,t,n,i){if(!d(e))throw new A("position is required.");if(!d(t))throw new A("velocity is required.");let s=O(n,qe.WGS84).geodeticSurfaceNormal(e,hs),r=f.cross(t,s,ys);f.equalsEpsilon(r,f.ZERO,X.EPSILON6)&&(r=f.clone(f.UNIT_X,r));let c=f.cross(r,t,gs);return f.normalize(c,c),f.cross(t,c,r),f.negate(r,r),f.normalize(r,r),d(i)||(i=new B),i[0]=t.x,i[1]=t.y,i[2]=t.z,i[3]=r.x,i[4]=r.y,i[5]=r.z,i[6]=c.x,i[7]=c.y,i[8]=c.z,i};var fo=new L(0,0,1,0,1,0,0,0,0,1,0,0,0,0,0,1),lo=new De,Gn=new f,ws=new f,bs=new B,Kn=new L,po=new L;$.basisTo2D=function(e,t,n){if(!d(e))throw new A("projection is required.");if(!d(t))throw new A("matrix is required.");if(!d(n))throw new A("result is required.");let i=L.getTranslation(t,ws),s=e.ellipsoid,r;if(f.equals(i,f.ZERO))r=f.clone(f.ZERO,Gn);else{let g=s.cartesianToCartographic(i,lo);r=e.project(g,Gn),f.fromElements(r.z,r.x,r.y,r)}let c=$.eastNorthUpToFixedFrame(i,s,Kn),u=L.inverseTransformation(c,po),p=L.getMatrix3(t,bs),b=L.multiplyByMatrix3(u,p,n);return L.multiply(fo,b,n),L.setTranslation(n,r,n),n};$.wgs84To2DModelMatrix=function(e,t,n){if(!d(e))throw new A("projection is required.");if(!d(t))throw new A("center is required.");if(!d(n))throw new A("result is required.");let i=e.ellipsoid,s=$.eastNorthUpToFixedFrame(t,i,Kn),r=L.inverseTransformation(s,po),c=i.cartesianToCartographic(t,lo),u=e.project(c,Gn);f.fromElements(u.z,u.x,u.y,u);let p=L.fromTranslation(u,Kn);return L.multiply(fo,r,n),L.multiply(p,n,n),n};var af=$;export{cn as a,Ct as b,er as c,Qs as d,wt as e,Je as f,ke as g,Wr as h,af as i};
